"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var CodeBuffer = (function () {
    function CodeBuffer(length) {
        this.cursor = 0;
        this.buf = Buffer.alloc(length);
    }
    CodeBuffer.prototype.push = function (uint8) {
        this.buf[this.cursor] = uint8;
        this.cursor++;
    };
    CodeBuffer.prototype.pushArray = function (octets) {
        for (var _i = 0, octets_1 = octets; _i < octets_1.length; _i++) {
            var octet = octets_1[_i];
            this.push(octet);
        }
    };
    CodeBuffer.prototype.skip = function (length) {
        this.cursor += length;
    };
    CodeBuffer.prototype.truncate = function () {
        return this.buf.slice(0, this.cursor);
    };
    return CodeBuffer;
}());
exports.default = CodeBuffer;
