"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var MnemonicVariations = (function () {
    function MnemonicVariations(mnemonics) {
        this.mnemonic = '';
        this.mnemonics = [];
        this.mnemonic = mnemonics[0].mnemonic;
        this.mnemonics = mnemonics;
    }
    MnemonicVariations.prototype.groupBySize = function () {
        var sizes = {};
        for (var _i = 0, _a = this.mnemonics; _i < _a.length; _i++) {
            var mnemonic = _a[_i];
            var size = mnemonic.operandSize;
            if (!sizes[size])
                sizes[size] = [];
            sizes[size].push(mnemonic);
        }
        return sizes;
    };
    MnemonicVariations.prototype.toJson = function () {
        return {
            mnemonic: this.mnemonic,
            definitions: this.mnemonics.map(function (mnemonic) { return mnemonic.toJson(); }),
        };
    };
    MnemonicVariations.prototype.toString = function () {
        return this.mnemonic.toUpperCase() + ":\n    " + this.mnemonics.map(function (mnemonic) { return mnemonic.toString(); }).join('\n    ');
    };
    return MnemonicVariations;
}());
exports.default = MnemonicVariations;
