"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var Hook = (function () {
    function Hook(args) {
        if (args === void 0) { args = []; }
        this.taps = [];
        this.args = args;
    }
    Hook.prototype.tap = function (opts, fn) {
        var options;
        if (typeof opts === "string")
            options = { name: opts };
        if (typeof options !== "object" || options === null)
            throw new Error("Invalid arguments to tap(options: Object, fn: function)");
        options = __assign({}, options, { type: 'sync', fn: fn });
        if (typeof options.name !== "string" || !options.name)
            throw new Error("Missing name for tap");
        this.taps.push(options);
    };
    Hook.prototype.call = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var result;
        var taps = this.taps;
        for (var i = 0; i < taps.length; i++) {
            result = taps[i].fn.apply(null, args);
            if (result !== void 0)
                return result;
        }
        return result;
    };
    return Hook;
}());
exports.default = Hook;
