"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var instruction_1 = require("../../instruction");
var ImmediateEthereum_1 = require("./ImmediateEthereum");
var operand_1 = require("./operand");
var InstructionEthereum = (function (_super) {
    __extends(InstructionEthereum, _super);
    function InstructionEthereum(mnemonic, ops, opts) {
        if (ops === void 0) { ops = null; }
        var _this = _super.call(this, ops, opts) || this;
        _this.length = 1;
        _this.lengthMax = 1;
        _this.immediate = null;
        _this.mnemonic = mnemonic;
        return _this;
    }
    InstructionEthereum.prototype.write = function (bin) {
        bin.push(this.mnemonic.opcode);
        if (this.immediate)
            this.immediate.write(bin);
    };
    InstructionEthereum.prototype.build = function () {
        _super.prototype.build.call(this);
        if (this.ops && this.ops.list.length) {
            var constant = this.ops.getFirstOfClass(operand_1.ConstantEthereum);
            this.length += constant.octets.length;
            this.lengthMax += constant.octets.length;
            if (constant)
                this.immediate = new ImmediateEthereum_1.default(constant);
        }
        return this;
    };
    return InstructionEthereum;
}(instruction_1.Instruction));
exports.InstructionEthereum = InstructionEthereum;
