"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var expression_1 = require("../../expression");
var Align = (function (_super) {
    __extends(Align, _super);
    function Align(by) {
        var _this = _super.call(this) || this;
        _this.length = expression_1.SIZE_UNKNOWN;
        _this.templates = [
            [0x00],
        ];
        _this.octets = [];
        _this.by = by;
        return _this;
    }
    Align.prototype.bytesMax = function () {
        return this.by - 1;
    };
    Align.prototype.write = function (bin) {
        bin.pushArray(this.octets);
    };
    Align.prototype.generateOctets = function () {
        if (!this.length)
            return;
        var bytes_left = this.bytes();
        var max_tpl = this.templates.length;
        while (bytes_left > 0) {
            if (bytes_left > max_tpl) {
                this.octets = this.octets.concat(this.templates[max_tpl - 1]);
                bytes_left -= max_tpl;
            }
            else {
                this.octets = this.octets.concat(this.templates[bytes_left - 1]);
                bytes_left = 0;
            }
        }
    };
    Align.prototype.calcOffset = function () {
        _super.prototype.calcOffset.call(this);
        var mod = (this.offset % this.by);
        this.length = mod ? this.by - mod : 0;
        this.generateOctets();
    };
    Align.prototype.toString = function (margin, comment) {
        if (margin === void 0) { margin = '    '; }
        if (comment === void 0) { comment = true; }
        var cmt = '';
        if (comment) {
            if (this.length >= 0) {
                var octets = '';
                if (this.length) {
                    octets = '0x' + this.octets.map(function (byte) {
                        var str = byte.toString(16).toUpperCase();
                        return byte <= 0xF ? '0' + str : str;
                    }).join(' 0x');
                }
                cmt = this.length + ' bytes ' + octets;
            }
            else
                cmt = "max " + this.bytesMax() + " bytes";
        }
        return this.formatToString(margin, 'align ' + this.by, cmt);
    };
    return Align;
}(expression_1.ExpressionVolatile));
exports.default = Align;
