"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Plugin_1 = require("../Plugin");
var Align_1 = require("./Align");
var operand_1 = require("../../operand");
var PluginUtil = (function (_super) {
    __extends(PluginUtil, _super);
    function PluginUtil() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    PluginUtil.prototype.onAsm = function (asm) {
        var _this = this;
        asm.hooks.command.tap('PluginData', function (name, args) {
            switch (name) {
                case 'align': return _this.align.apply(_this, args);
                case 'label': return _this.label.apply(_this, args);
            }
        });
        asm.hooks.ops.tap('PluginData', function (operands, size) { return new operand_1.Operands(operands, size); });
    };
    PluginUtil.prototype.align = function (bytes, fill) {
        if (bytes === void 0) { bytes = 4; }
        if (fill === void 0) { fill = null; }
        var align = new Align_1.default(bytes);
        if (fill !== null) {
            if (typeof fill === 'number')
                align.templates = [[fill]];
            else
                align.templates = fill;
        }
        return this.asm.insert(align);
    };
    PluginUtil.prototype.label = function (name) {
        return this.asm.insert(this.asm.lbl(name));
    };
    return PluginUtil;
}(Plugin_1.default));
exports.default = PluginUtil;
