"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var Plugin_1 = require("../Plugin");
var instruction_1 = require("./instruction");
var __map_1 = require("./__generated/__map");
var operand_1 = require("../../operand");
var instruction_2 = require("../x86/instruction");
var PluginX64 = (function (_super) {
    __extends(PluginX64, _super);
    function PluginX64() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.matchFilter = function (options) { return function (match) {
            if (!(_this.asm.opts.mode & match.mnemonic.mode))
                return false;
            var needsEvex = options.mask || (options.z !== void 0);
            if (needsEvex && !match.mnemonic.evex)
                return false;
            return true;
        }; };
        return _this;
    }
    PluginX64.prototype.onAsm = function (asm) {
        var _this = this;
        asm.hooks.instruction.tap('PluginX64', function () { return new instruction_1.InstructionX64(); });
        asm.hooks.command.tap('PluginX64', function (name, args) {
            if (__map_1.default[name]) {
                return _this.mnemonic(name, args);
            }
        });
    };
    PluginX64.prototype.normalizeInstructionOptions = function (opts) {
        var options;
        if (opts === void 0) {
            options = {};
        }
        else if (typeof opts === 'number') {
            options = {
                size: opts
            };
        }
        else if (typeof opts === 'object') {
            options = opts;
        }
        else
            throw TypeError("options must be a number or object.");
        if (options.size === void 0)
            options.size = operand_1.SIZE.ANY;
        return options;
    };
    PluginX64.prototype.mnemonic = function (name, args) {
        var variations = require('./__generated/' + name).default;
        var uiOperands = args[0];
        if (uiOperands && !Array.isArray(uiOperands)) {
            uiOperands = [uiOperands];
        }
        var options = this.normalizeInstructionOptions(args[1]);
        var operands = this.asm.ops(uiOperands, options.size);
        if (options.size <= 0) {
            for (var _i = 0, _a = operands.list; _i < _a.length; _i++) {
                var operand = _a[_i];
                if (operand instanceof operand_1.Register) {
                    options.size = operand.size;
                    break;
                }
            }
        }
        var matches = variations.matches(operands, options, this.matchFilter(options));
        var instructionSet = new instruction_2.InstructionSetX86(operands, matches, options);
        this.asm.insert(instructionSet);
        var insn = instructionSet.pickShortestInstruction();
        if (insn) {
            this.asm.replace(insn, instructionSet.index);
            return insn;
        }
        else
            return instructionSet;
    };
    return PluginX64;
}(Plugin_1.default));
exports.default = PluginX64;
