"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var x64_mnemonic_map = {
    "cpuid": 1,
    "int": 1,
    "aaa": 1,
    "aad": 1,
    "aam": 1,
    "aas": 1,
    "addpd": 1,
    "vaddpd": 1,
    "addps": 1,
    "vaddps": 1,
    "kandw": 1,
    "addsd": 1,
    "vaddsd": 1,
    "addss": 1,
    "vaddss": 1,
    "addsubpd": 1,
    "vaddsubpd": 1,
    "addsubps": 1,
    "vaddsubps": 1,
    "aesdec": 1,
    "vaesdec": 1,
    "aesdeclast": 1,
    "vaesdeclast": 1,
    "aesenc": 1,
    "vaesenc": 1,
    "aesenclast": 1,
    "vaesenclast": 1,
    "aesimc": 1,
    "vaesimc": 1,
    "aeskeygenassist": 1,
    "vaeskeygenassist": 1,
    "andn": 1,
    "andpd": 1,
    "vandpd": 1,
    "andps": 1,
    "vandps": 1,
    "andnpd": 1,
    "vandnpd": 1,
    "andnps": 1,
    "vandnps": 1,
    "arpl": 1,
    "blendpd": 1,
    "vblendpd": 1,
    "bextr": 1,
    "blendps": 1,
    "vblendps": 1,
    "blendvpd": 1,
    "vblendvpd": 1,
    "blendvps": 1,
    "vblendvps": 1,
    "blsi": 1,
    "blsmsk": 1,
    "blsr": 1,
    "bndcl": 1,
    "bndcu": 1,
    "bndcn": 1,
    "bndmk": 1,
    "bndldx": 1,
    "bndmov": 1,
    "bndstx": 1,
    "bound": 1,
    "bzhi": 1,
    "clflush": 1,
    "clflushopt": 1,
    "clts": 1,
    "cmppd": 1,
    "vcmppd": 1,
    "cmpps": 1,
    "vcmpps": 1,
    "cmpsd": 1,
    "vcmpsd": 1,
    "cmpss": 1,
    "vcmpss": 1,
    "comisd": 1,
    "vcomisd": 1,
    "comiss": 1,
    "vcomiss": 1,
    "cvtdq2pd": 1,
    "vcvtdq2pd": 1,
    "cvtdq2ps": 1,
    "vcvtdq2ps": 1,
    "cvtpd2dq": 1,
    "vcvtpd2dq": 1,
    "cvtpd2pi": 1,
    "cvtpd2ps": 1,
    "vcvtpd2ps": 1,
    "cvtpi2pd": 1,
    "cvtpi2ps": 1,
    "cvtps2dq": 1,
    "vcvtps2dq": 1,
    "cvtps2pd": 1,
    "vcvtps2pd": 1,
    "cvtps2pi": 1,
    "cvtsd2si": 1,
    "vcvtsd2si": 1,
    "cvtsd2ss": 1,
    "vcvtsd2ss": 1,
    "cvtsi2sd": 1,
    "vcvtsi2sd": 1,
    "cvtsi2ss": 1,
    "vcvtsi2ss": 1,
    "cvtss2sd": 1,
    "vcvtss2sd": 1,
    "cvtss2si": 1,
    "vcvtss2si": 1,
    "cvttpd2dq": 1,
    "vcvttpd2dq": 1,
    "cvttpd2pi": 1,
    "cvttps2dq": 1,
    "vcvttps2dq": 1,
    "cvttps2pi": 1,
    "cvttsd2si": 1,
    "vcvttsd2si": 1,
    "cvttss2si": 1,
    "vcvttss2si": 1,
    "daa": 1,
    "das": 1,
    "divpd": 1,
    "vdivpd": 1,
    "divps": 1,
    "vdivps": 1,
    "divsd": 1,
    "vdivsd": 1,
    "divss": 1,
    "vdivss": 1,
    "dppd": 1,
    "vdppd": 1,
    "dpps": 1,
    "vdpps": 1,
    "emms": 1,
    "extractps": 1,
    "vextractps": 1,
    "f2xm1": 1,
    "fabs": 1,
    "fadd": 1,
    "faddp": 1,
    "fiadd": 1,
    "fbld": 1,
    "fbstp": 1,
    "fchs": 1,
    "fclex": 1,
    "fnclex": 1,
    "fcmovb": 1,
    "fcmove": 1,
    "fcmovbe": 1,
    "fcmovu": 1,
    "fcmovnb": 1,
    "fcmovne": 1,
    "fcmovnbe": 1,
    "fcmovnu": 1,
    "fcom": 1,
    "fcomp": 1,
    "fcompp": 1,
    "fcomi": 1,
    "fcomip": 1,
    "fucomi": 1,
    "fucomip": 1,
    "fcos": 1,
    "fdecstp": 1,
    "fdiv": 1,
    "fdivp": 1,
    "fidiv": 1,
    "fdivr": 1,
    "fdivrp": 1,
    "fidivr": 1,
    "ffree": 1,
    "ficom": 1,
    "ficomp": 1,
    "fild": 1,
    "fincstp": 1,
    "finit": 1,
    "fninit": 1,
    "fist": 1,
    "fistp": 1,
    "fisttp": 1,
    "fld": 1,
    "fld1": 1,
    "fldl2t": 1,
    "fldl2e": 1,
    "fldpi": 1,
    "fldlg2": 1,
    "fldln2": 1,
    "fldz": 1,
    "fldcw": 1,
    "fldenv": 1,
    "fmul": 1,
    "fmulp": 1,
    "fimul": 1,
    "fnop": 1,
    "fpatan": 1,
    "fprem": 1,
    "fprem1": 1,
    "fptan": 1,
    "frndint": 1,
    "frstor": 1,
    "fsave": 1,
    "fnsave": 1,
    "fscale": 1,
    "fsin": 1,
    "fsincos": 1,
    "fsqrt": 1,
    "fst": 1,
    "fstp": 1,
    "fstcw": 1,
    "fnstcw": 1,
    "fstenv": 1,
    "fnstenv": 1,
    "fstsw": 1,
    "fnstsw": 1,
    "fsub": 1,
    "fsubp": 1,
    "fisub": 1,
    "fsubr": 1,
    "fsubrp": 1,
    "fisubr": 1,
    "ftst": 1,
    "fucom": 1,
    "fucomp": 1,
    "fucompp": 1,
    "fxam": 1,
    "fxch": 1,
    "fxrstor": 1,
    "fxrstor64": 1,
    "fxsave": 1,
    "fxsave64": 1,
    "fxtract": 1,
    "fyl2x": 1,
    "fyl2xp1": 1,
    "haddpd": 1,
    "vhaddpd": 1,
    "haddps": 1,
    "vhaddps": 1,
    "hlt": 1,
    "hsubpd": 1,
    "vhsubpd": 1,
    "hsubps": 1,
    "vhsubps": 1,
    "insertps": 1,
    "vinsertps": 1,
    "invd": 1,
    "invlpg": 1,
    "invpcid": 1,
    "lahf": 1,
    "lar": 1,
    "lddqu": 1,
    "vlddqu": 1,
    "ldmxcsr": 1,
    "vldmxcsr": 1,
    "lfence": 1,
    "lgdt": 1,
    "lidt": 1,
    "lldt": 1,
    "lmsw": 1,
    "lock": 1,
    "lsl": 1,
    "ltr": 1,
    "lzcnt": 1,
    "maskmovdqu": 1,
    "vmaskmovdqu": 1,
    "maskmovq": 1,
    "maxpd": 1,
    "vmaxpd": 1,
    "maxps": 1,
    "vmaxps": 1,
    "maxsd": 1,
    "vmaxsd": 1,
    "maxss": 1,
    "vmaxss": 1,
    "mfence": 1,
    "minpd": 1,
    "vminpd": 1,
    "minps": 1,
    "vminps": 1,
    "minsd": 1,
    "vminsd": 1,
    "minss": 1,
    "vminss": 1,
    "monitor": 1,
    "movapd": 1,
    "vmovapd": 1,
    "movaps": 1,
    "vmovaps": 1,
    "movd": 1,
    "vmovd": 1,
    "movq": 1,
    "vmovq": 1,
    "movddup": 1,
    "vmovddup": 1,
    "movdqa": 1,
    "vmovdqa": 1,
    "movdqu": 1,
    "vmovdqu": 1,
    "movdq2q": 1,
    "movhlps": 1,
    "vmovhlps": 1,
    "movhpd": 1,
    "vmovhpd": 1,
    "movhps": 1,
    "vmovhps": 1,
    "movlhps": 1,
    "vmovlhps": 1,
    "movlpd": 1,
    "vmovlpd": 1,
    "movlps": 1,
    "vmovlps": 1,
    "movmskpd": 1,
    "vmovmskpd": 1,
    "movmskps": 1,
    "vmovmskps": 1,
    "movntdqa": 1,
    "vmovntdqa": 1,
    "movntdq": 1,
    "vmovntdq": 1,
    "movnti": 1,
    "movntpd": 1,
    "vmovntpd": 1,
    "movntps": 1,
    "vmovntps": 1,
    "movntq": 1,
    "movq2dq": 1,
    "movsd": 1,
    "vmovsd": 1,
    "movshdup": 1,
    "vmovshdup": 1,
    "movsldup": 1,
    "vmovsldup": 1,
    "movss": 1,
    "vmovss": 1,
    "movupd": 1,
    "vmovupd": 1,
    "movups": 1,
    "vmovups": 1,
    "mpsadbw": 1,
    "vmpsadbw": 1,
    "mulps": 1,
    "vmulps": 1,
    "mulsd": 1,
    "vmulsd": 1,
    "mulss": 1,
    "vmulss": 1,
    "mulx": 1,
    "mwait": 1,
    "orpd": 1,
    "vorpd": 1,
    "orps": 1,
    "vorps": 1,
    "pabsb": 1,
    "vpabsb": 1,
    "pabsw": 1,
    "vpabsw": 1,
    "pabsd": 1,
    "vpabsd": 1,
    "packsswb": 1,
    "vpacksswb": 1,
    "packssdw": 1,
    "vpackssdw": 1,
    "packusdw": 1,
    "vpackusdw": 1,
    "pause": 1,
    "mov": 1,
    "movabs": 1,
    "cmove": 1,
    "cmovz": 1,
    "cmovne": 1,
    "cmovnz": 1,
    "cmova": 1,
    "cmovnbe": 1,
    "cmovae": 1,
    "cmovnb": 1,
    "cmovb": 1,
    "cmovnae": 1,
    "cmovbe": 1,
    "cmovna": 1,
    "cmovg": 1,
    "cmovnle": 1,
    "cmovge": 1,
    "cmovnl": 1,
    "cmovl": 1,
    "cmovnge": 1,
    "cmovle": 1,
    "cmovng": 1,
    "cmovc": 1,
    "cmovnc": 1,
    "cmovo": 1,
    "cmovno": 1,
    "cmovs": 1,
    "cmovns": 1,
    "cmovp": 1,
    "cmovpe": 1,
    "cmovnp": 1,
    "cmovpo": 1,
    "xchg": 1,
    "bswap": 1,
    "xadd": 1,
    "cmpxchg": 1,
    "cmpxchg8b": 1,
    "cmpxchg16b": 1,
    "push": 1,
    "pop": 1,
    "cwd": 1,
    "cdq": 1,
    "cqo": 1,
    "cbw": 1,
    "cwde": 1,
    "cdqe": 1,
    "movsx": 1,
    "movsxd": 1,
    "movzx": 1,
    "adcx": 1,
    "adox": 1,
    "add": 1,
    "adc": 1,
    "sub": 1,
    "sbb": 1,
    "imul": 1,
    "mul": 1,
    "idiv": 1,
    "div": 1,
    "inc": 1,
    "dec": 1,
    "neg": 1,
    "cmp": 1,
    "and": 1,
    "or": 1,
    "xor": 1,
    "not": 1,
    "sar": 1,
    "shr": 1,
    "shl": 1,
    "sal": 1,
    "shrd": 1,
    "shld": 1,
    "ror": 1,
    "rol": 1,
    "rcr": 1,
    "rcl": 1,
    "bt": 1,
    "bts": 1,
    "btr": 1,
    "btc": 1,
    "bsf": 1,
    "bsr": 1,
    "sete": 1,
    "setz": 1,
    "setne": 1,
    "setnz": 1,
    "seta": 1,
    "setnbe": 1,
    "setae": 1,
    "setnb": 1,
    "setnc": 1,
    "setb": 1,
    "setnae": 1,
    "setc": 1,
    "setbe": 1,
    "setna": 1,
    "setg": 1,
    "setnle": 1,
    "setge": 1,
    "setnl": 1,
    "setl": 1,
    "setnge": 1,
    "setle": 1,
    "setng": 1,
    "sets": 1,
    "setns": 1,
    "seto": 1,
    "setno": 1,
    "setp": 1,
    "setpe": 1,
    "setnp": 1,
    "setpo": 1,
    "test": 1,
    "crc32": 1,
    "popcnt": 1,
    "jmp": 1,
    "ljmp": 1,
    "jecxz": 1,
    "jrcxz": 1,
    "ja": 1,
    "jae": 1,
    "jb": 1,
    "jbe": 1,
    "jc": 1,
    "je": 1,
    "jg": 1,
    "jge": 1,
    "jl": 1,
    "jle": 1,
    "jna": 1,
    "jnae": 1,
    "jnb": 1,
    "jnbe": 1,
    "jnc": 1,
    "jne": 1,
    "jng": 1,
    "jnge": 1,
    "jnl": 1,
    "jnle": 1,
    "jno": 1,
    "jnp": 1,
    "jns": 1,
    "jnz": 1,
    "jo": 1,
    "jp": 1,
    "jpe": 1,
    "jpo": 1,
    "js": 1,
    "jz": 1,
    "loop": 1,
    "loope": 1,
    "loopz": 1,
    "loopne": 1,
    "loopnz": 1,
    "call": 1,
    "lcall": 1,
    "ret": 1,
    "lret": 1,
    "iret": 1,
    "iretd": 1,
    "iretq": 1,
    "movs": 1,
    "cmps": 1,
    "scas": 1,
    "lods": 1,
    "lodsb": 1,
    "lodsw": 1,
    "lodsd": 1,
    "lodsq": 1,
    "stos": 1,
    "in": 1,
    "out": 1,
    "ins": 1,
    "insb": 1,
    "insw": 1,
    "insd": 1,
    "outs": 1,
    "enter": 1,
    "leave": 1,
    "stc": 1,
    "clc": 1,
    "cmc": 1,
    "cld": 1,
    "std": 1,
    "pushf": 1,
    "popf": 1,
    "sti": 1,
    "cli": 1,
    "clac": 1,
    "lds": 1,
    "les": 1,
    "lfs": 1,
    "lgs": 1,
    "lss": 1,
    "lea": 1,
    "nop": 1,
    "ud2": 1,
    "xlat": 1,
    "movbe": 1,
    "prefetchw": 1,
    "prefetchwt1": 1,
    "cflush": 1,
    "cflushopt": 1,
    "xsave": 1,
    "xsavec": 1,
    "xsaveopt": 1,
    "xrstor": 1,
    "xgetbv": 1,
    "rdrand": 1,
    "rdseed": 1,
    "syscall": 1,
    "sysret": 1,
    "sysenter": 1,
    "sysexit": 1,
    "vextractf128": 1,
    "vcvtph2ps": 1,
    "vfmadd132pd": 1
};
exports.default = x64_mnemonic_map;
