"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var o = require("../x86/operand");
var t = require("../x86/table");
var atoms_1 = require("../x86/atoms");
var consts_1 = require("../x86/consts");
var atoms_2 = require("./atoms");
function lazy(part, mnemonic) {
    return require('./table/' + part).default[mnemonic];
}
exports.defaults = __assign({}, t.defaults, { rex: false, ds: atoms_1.S.D });
function tpl_not(o, or, lock) {
    if (o === void 0) { o = 0xF6; }
    if (or === void 0) { or = 2; }
    if (lock === void 0) { lock = true; }
    return [{ o: o + 1, or: or, lock: lock },
        { o: o, ops: [atoms_1.rm8] },
        { ops: [atoms_1.rm16] },
        { ops: [atoms_1.rm32] },
        { ops: [atoms_1.rm64] },
    ];
}
function tpl_bt(o_r, or_imm, o_imm) {
    if (o_r === void 0) { o_r = 0x0FA3; }
    if (or_imm === void 0) { or_imm = 4; }
    if (o_imm === void 0) { o_imm = 0x0FBA; }
    return [{ en: 'mr' },
        { o: o_r, ops: [atoms_1.rm16, atoms_1.r16] },
        { o: o_r, ops: [atoms_1.rm32, atoms_1.r32] },
        { o: o_r, ops: [atoms_1.rm64, atoms_1.r64] },
        { o: o_imm, or: or_imm, ops: [atoms_1.rm16, atoms_1.imm8] },
        { o: o_imm, or: or_imm, ops: [atoms_1.rm32, atoms_1.imm8] },
        { o: o_imm, or: or_imm, ops: [atoms_1.rm64, atoms_1.imm8] },
    ];
}
function tpl_bsf(op) {
    if (op === void 0) { op = 0x0FBC; }
    return [{ o: op },
        { ops: [atoms_1.r16, atoms_1.rm16] },
        { ops: [atoms_1.r32, atoms_1.rm32] },
        { ops: [atoms_1.r64, atoms_1.rm64] },
    ];
}
function tpl_ja(op, op2) {
    if (op === void 0) { op = 0x77; }
    if (op2 === void 0) { op2 = 0x0F87; }
    return [{},
        { o: op, ops: [atoms_1.rel8] },
        { o: op2, ops: [atoms_1.rel32] },
    ];
}
function tpl_cmovc(op) {
    if (op === void 0) { op = 0x0F42; }
    return [{ o: op },
        { ops: [atoms_1.r16, atoms_1.rm16] },
        { ops: [atoms_1.r32, atoms_1.rm32] },
        { ops: [atoms_1.r64, atoms_1.rm64] },
    ];
}
function tpl_xadd(op, lock) {
    if (op === void 0) { op = 0; }
    if (lock === void 0) { lock = true; }
    return [{ o: op + 1, en: 'mr', lock: lock },
        { o: op, ops: [atoms_1.rm8, atoms_1.r8] },
        { ops: [atoms_1.rm16, atoms_1.r16] },
        { ops: [atoms_1.rm32, atoms_1.r32] },
        { ops: [atoms_1.rm64, atoms_1.r64] },
    ];
}
function tpl_movs(op) {
    if (op === void 0) { op = 0xA4; }
    return [{ o: op + 1 },
        { o: op, s: atoms_1.S.B },
        { s: atoms_1.S.W },
        { s: atoms_1.S.D },
        { s: atoms_1.S.Q },
    ];
}
function tpl_lss(op) {
    if (op === void 0) { op = 0x0FB2; }
    return [{ o: op },
        { ops: [atoms_1.rm16, atoms_1.m] },
        { ops: [atoms_1.rm32, atoms_1.m] },
        { ops: [atoms_1.rm64, atoms_1.m] },
    ];
}
function tpl_blsi(op, or) {
    if (op === void 0) { op = 0xF3; }
    if (or === void 0) { or = 3; }
    return [{ o: op, or: or, en: 'vm', ext: [consts_1.EXT.BMI1] },
        { vex: 'NDD.LZ.0F38.W0', ops: [atoms_1.r32, atoms_1.rm32] },
        { vex: 'NDD.LZ.0F38.W1', ops: [atoms_1.r64, atoms_1.rm64], mod: atoms_1.M.X64 },
    ];
}
function tpl_bndcl(op) {
    if (op === void 0) { op = 0xF30F1A; }
    return [{ o: op, ext: [consts_1.EXT.MPX] },
        { ops: [atoms_1.bnd, atoms_1.rm32], mod: atoms_1.M.X32, s: atoms_1.S.D },
        { ops: [atoms_1.bnd, atoms_1.rm64], mod: atoms_1.M.X64, s: atoms_1.S.Q },
    ];
}
var _dec = tpl_not(0xFE, 1);
_dec.push({ o: 0x48, r: true, ops: [atoms_1.r16], mod: atoms_1.M.COMP | atoms_1.M.LEG });
_dec.push({ o: 0x48, r: true, ops: [atoms_1.r32], mod: atoms_1.M.COMP | atoms_1.M.LEG });
var _inc = tpl_not(0xFE, 0);
_inc.push({ o: 0x40, r: true, ops: [atoms_1.r16], mod: atoms_1.M.COMP | atoms_1.M.LEG });
_inc.push({ o: 0x40, r: true, ops: [atoms_1.r32], mod: atoms_1.M.COMP | atoms_1.M.LEG });
exports.table = __assign({}, t.table, { aaa: require('./mnemonics/aaa').default, aad: require('./mnemonics/aad').default, aam: [{ mod: atoms_1.M.OLD },
        { o: 0xD40A },
        { o: 0xD4, ops: [atoms_1.imm8] },
    ], aas: [{ o: 0x3F, mod: atoms_1.M.OLD }], addpd: [{ o: 0x660F58, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vaddpd: [{ o: 0x58, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.66.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: 'NDS.256.66.0F.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], addps: [{ o: 0x0F58, ops: atoms_1.xmm_xmmm, ext: atoms_2.ext_sse }], get vaddps() { return lazy('avx', 'vaddps'); }, kandw: [{},
        { o: 0x41, vex: 'L1.0F.W0', ops: [], ext: [consts_1.EXT.AVX512F] },
    ], addsd: [{ o: 0xF20F58, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vaddsd: [{ o: 0x58, vex: 'NDS.LIG.F2.0F.WIG', en: 'rvm', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.AVX] }], addss: [{ o: 0xF30F58, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vaddss: [{ o: 0x58, vex: 'NDS.LIG.F3.0F.WIG', en: 'rvm', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.AVX] }], addsubpd: [{ o: 0x660FD0, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE3] }], vaddsubpd: [{ o: 0xD0, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.66.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: 'NDS.256.66.0F.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], addsubps: [{ o: 0xF20FD0, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE3] }], vaddsubps: [{ o: 0xD0, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.F2.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: 'NDS.256.F2.0F.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], aesdec: [{ o: 0x0F38DE, pfx: [0x66], ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.AES] }], vaesdec: [{ o: 0xDE, vex: 'NDS.128.66.0F38.WIG', en: 'rvm', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.AES, consts_1.EXT.AVX] }], aesdeclast: [{ o: 0x0F38DF, pfx: [0x66], ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.AES] }], vaesdeclast: [{ o: 0xDF, vex: 'NDS.128.66.0F38.WIG', en: 'rvm', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.AES, consts_1.EXT.AVX] }], aesenc: [{ o: 0x0F38DC, pfx: [0x66], ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.AES] }], vaesenc: [{ o: 0xDC, vex: 'NDS.128.66.0F38.WIG', en: 'rvm', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.AES, consts_1.EXT.AVX] }], aesenclast: [{ o: 0x0F38DD, pfx: [0x66], ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.AES] }], vaesenclast: [{ o: 0xDD, vex: 'NDS.128.66.0F38.WIG', en: 'rvm', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.AES, consts_1.EXT.AVX] }], aesimc: [{ o: 0x0F38DB, pfx: [0x66], ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.AES] }], vaesimc: [{ o: 0xDB, vex: '128.66.0F38.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.AES, consts_1.EXT.AVX] }], aeskeygenassist: [{ o: 0x0F3ADF, pfx: [0x66], ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8], ext: [consts_1.EXT.AES] }], vaeskeygenassist: [{ o: 0xDF, vex: '128.66.0F3A.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8], ext: [consts_1.EXT.AES, consts_1.EXT.AVX] }], andn: [{ o: 0xF2, en: 'rvm', ext: [consts_1.EXT.BMI1] },
        { vex: 'NDS.LZ.0F38.W0', ops: [atoms_1.r32, atoms_1.r32, atoms_1.rm32] },
        { vex: 'NDS.LZ.0F38.W1', ops: [atoms_1.r64, atoms_1.r64, atoms_1.rm64], mod: atoms_1.M.X64 },
    ], andpd: [{ o: 0x660F54, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vandpd: [{ o: 0x54, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.66.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: 'NDS.256.66.0F.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], andps: [{ o: 0x0F54, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE] }], vandps: [{ o: 0x54, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: 'NDS.256.0F.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], andnpd: [{ o: 0x660F55, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vandnpd: [{ o: 0x55, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.66.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: 'NDS.256.66.0F.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], andnps: [{ o: 0x0F55, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE] }], vandnps: [{ o: 0x55, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: 'NDS.256.0F.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], arpl: [{ o: 0x63, ops: [atoms_1.rm16, atoms_1.r16], mod: atoms_1.M.OLD }], blendpd: [{ o: 0x0F3A0F, pfx: [0x66], ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8], ext: [consts_1.EXT.SSE4_1] }], vblendpd: [{ o: 0x0D, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.66.0F3A.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8] },
        { vex: 'NDS.256.66.0F3A.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m], atoms_1.imm8] },
    ], bextr: [{ o: 0xF7, en: 'rmv', ext: [consts_1.EXT.BMI1] },
        { vex: 'NDS.LZ.0F38.W0', ops: [atoms_1.r32, atoms_1.rm32, atoms_1.r32] },
        { vex: 'NDS.LZ.0F38.W1', ops: [atoms_1.r64, atoms_1.rm64, atoms_1.r64], mod: atoms_1.M.X64 },
    ], blendps: [{ o: 0x0F3A0C, pfx: [0x66], ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8], ext: [consts_1.EXT.SSE4_1] }], vblendps: [{ o: 0x0C, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.66.0F3A.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8] },
        { vex: 'NDS.256.66.0F3A.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m], atoms_1.imm8] },
    ], blendvpd: [{ o: 0x0F3815, pfx: [0x66], ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE4_1] }], vblendvpd: [{ o: 0x4B, en: 'rvmr', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.66.0F3A.W0', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.xmm] },
        { vex: 'NDS.256.66.0F3A.W0', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m], atoms_1.ymm] },
    ], blendvps: [{ o: 0x0F3814, pfx: [0x66], ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE4_1] }], vblendvps: [{ o: 0x4A, en: 'rvmr', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.66.0F3A.W0', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.xmm] },
        { vex: 'NDS.256.66.0F3A.W0', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m], atoms_1.ymm] },
    ], blsi: tpl_blsi(), blsmsk: tpl_blsi(0xF3, 2), blsr: tpl_blsi(0xF3, 1), bndcl: tpl_bndcl(), bndcu: tpl_bndcl(0xF20F1A), bndcn: tpl_bndcl(0xF20F1B), bndmk: tpl_bndcl(0xF30F1B), bndldx: [{ o: 0x0F1A, ops: [atoms_1.bnd, atoms_1.m], ext: [consts_1.EXT.MPX] }], bndmov: [{ pfx: [0x66, 0x0F], ext: [consts_1.EXT.MPX] },
        { o: 0x1A, ops: [atoms_1.bnd, [atoms_1.bnd, atoms_1.m]], dbit: true },
        { o: 0x1B, ops: [[atoms_1.bnd, atoms_1.m], atoms_1.bnd], en: 'mr', dbit: true },
    ], bndstx: [{ o: 0x0F1B, ops: [atoms_1.m, atoms_1.bnd], en: 'mr', ext: [consts_1.EXT.MPX] }], bound: [{ o: 0x62, mod: atoms_1.M.OLD },
        { ops: [atoms_1.r16, atoms_1.m] },
        { ops: [atoms_1.r32, atoms_1.m] },
    ], bzhi: [{ o: 0xF5, en: 'rmv', ext: [consts_1.EXT.BMI2] },
        { vex: 'NDS.LZ.0F38.W0', ops: [atoms_1.r32, atoms_1.rm32, atoms_1.r32] },
        { vex: 'NDS.LZ.0F38.W1', ops: [atoms_1.r64, atoms_1.rm64, atoms_1.r64], mod: atoms_1.M.X64 },
    ], clflush: [{ o: 0x0FAE, or: 7, ops: [atoms_1.m] }], clflushopt: [{ o: 0x660FAE, or: 7, ops: [atoms_1.m] }], clts: [{ o: 0x0F06 }], cmppd: [{ o: 0x660FC2, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8], ext: [consts_1.EXT.SSE2] }], vcmppd: [{ o: 0xC2, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.66.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8] },
        { vex: 'NDS.256.66.0F.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m], atoms_1.imm8] },
    ], cmpps: [{ o: 0x0FC2, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8], ext: [consts_1.EXT.SSE] }], vcmpps: [{ o: 0xC2, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.0F.WIG C2', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8] },
        { vex: 'NDS.256.0F.WIG C2', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m], atoms_1.imm8] },
    ], cmpsd: [{ o: 0xF20FC2, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8], ext: [consts_1.EXT.SSE2] }], vcmpsd: [{ o: 0xC2, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.LIG.F2.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8] },
    ], cmpss: [{ o: 0xF30FC2, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8], ext: [consts_1.EXT.SSE] }], vcmpss: [{ o: 0xC2, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.LIG.F3.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8] },
    ], comisd: [{ o: 0x660F2F, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vcomisd: [{ o: 0x2F, vex: 'LIG.66.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.AVX] }], comiss: [{ o: 0x0F2F, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE] }], vcomiss: [{ o: 0x2F, vex: 'LIG.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.AVX] }], cvtdq2pd: [{ o: 0xF30FE6, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vcvtdq2pd: [{ o: 0xE6, ext: [consts_1.EXT.AVX] },
        { vex: '128.F3.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: '256.F3.0F.WIG', ops: [atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], cvtdq2ps: [{ o: 0x0F5B, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vcvtdq2ps: [{ o: 0x5B, ext: [consts_1.EXT.AVX] },
        { vex: '128.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: '256.0F.WIG', ops: [atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], cvtpd2dq: [{ o: 0xF20FE6, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vcvtpd2dq: [{ o: 0xE6, ext: [consts_1.EXT.AVX] },
        { vex: '128.F2.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: '256.F2.0F.WIG', ops: [atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], cvtpd2pi: [{ o: 0x660F2D, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] }], cvtpd2ps: [{ o: 0x660F5A, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vcvtpd2ps: [{ o: 0x5A, ext: [consts_1.EXT.AVX] },
        { vex: '128.66.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: '256.66.0F.WIG', ops: [atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], cvtpi2pd: [{ o: 0x660F2A, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] }], cvtpi2ps: [{ o: 0x0F2A, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] }], cvtps2dq: [{ o: 0x660F5B, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vcvtps2dq: [{ o: 0x5B, ext: [consts_1.EXT.AVX] },
        { vex: '128.66.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: '256.66.0F.WIG', ops: [atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], cvtps2pd: [{ o: 0x0F5A, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vcvtps2pd: [{ o: 0x5A, ext: [consts_1.EXT.AVX] },
        { vex: '128.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: '256.0F.WIG', ops: [atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], cvtps2pi: [{ o: 0x0F2D, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] }], cvtsd2si: [{ o: 0xF20F2D, ops: [atoms_1.r32, [atoms_1.xmm, atoms_1.m]], s: atoms_1.S.D, ext: [consts_1.EXT.SSE2] }], vcvtsd2si: [{ o: 0x2D, ext: [consts_1.EXT.AVX] },
        { o: 0x0F2D, pfx: [0xF2], ops: [atoms_1.r64, [atoms_1.xmm, atoms_1.m]], s: atoms_1.S.Q, ext: [consts_1.EXT.SSE2], mod: atoms_1.M.X64 },
        { vex: 'LIG.F2.0F.W0', ops: [atoms_1.r32, [atoms_1.xmm, atoms_1.m]], s: atoms_1.S.D },
        { vex: 'LIG.F2.0F.W1', ops: [atoms_1.r64, [atoms_1.xmm, atoms_1.m]], s: atoms_1.S.Q, mod: atoms_1.M.X64 },
    ], cvtsd2ss: [{ o: 0xF20F5A, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vcvtsd2ss: [{ o: 0x5A, vex: 'NDS.LIG.F2.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], en: 'rvm', ext: [consts_1.EXT.AVX] }], cvtsi2sd: [{ o: 0x0F2A, pfx: [0xF2], ext: [consts_1.EXT.SSE2] },
        { ops: [atoms_1.xmm, atoms_1.rm32], s: atoms_1.S.D },
        { ops: [atoms_1.xmm, atoms_1.rm64], s: atoms_1.S.Q },
    ], vcvtsi2sd: [{ o: 0x2A, ext: [consts_1.EXT.AVX], en: 'rvm' },
        { vex: 'NDS.LIG.F2.0F.W0', ops: [atoms_1.xmm, atoms_1.xmm, atoms_1.rm32], s: atoms_1.S.D },
        { vex: 'NDS.LIG.F2.0F.W1', ops: [atoms_1.xmm, atoms_1.xmm, atoms_1.rm64], s: atoms_1.S.Q },
    ], cvtsi2ss: [{ o: 0x0F2A, pfx: [0xF3], ext: [consts_1.EXT.SSE] },
        { ops: [atoms_1.xmm, atoms_1.rm32], s: atoms_1.S.D },
        { ops: [atoms_1.xmm, atoms_1.rm64], s: atoms_1.S.Q },
    ], vcvtsi2ss: [{ o: 0x2A, ext: [consts_1.EXT.AVX], en: 'rvm' },
        { vex: 'NDS.LIG.F3.0F.W0', ops: [atoms_1.xmm, atoms_1.xmm, atoms_1.rm32], s: atoms_1.S.D },
        { vex: 'NDS.LIG.F3.0F.W1', ops: [atoms_1.xmm, atoms_1.xmm, atoms_1.rm64], s: atoms_1.S.Q },
    ], cvtss2sd: [{ o: 0xF30F5A, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vcvtss2sd: [{ o: 0x5A, vex: 'NDS.LIG.F3.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], en: 'rvm', ext: [consts_1.EXT.AVX] }], cvtss2si: [{ o: 0x0F2D, pfx: [0xF3], ext: [consts_1.EXT.SSE] },
        { ops: [atoms_1.r32, [atoms_1.xmm, atoms_1.m]], s: atoms_1.S.D },
        { ops: [atoms_1.r64, [atoms_1.xmm, atoms_1.m]], s: atoms_1.S.Q, mod: atoms_1.M.X64 },
    ], vcvtss2si: [{ o: 0x2D, ext: [consts_1.EXT.AVX] },
        { vex: 'LIG.F3.0F.W0', ops: [atoms_1.r32, [atoms_1.xmm, atoms_1.m]], s: atoms_1.S.D },
        { vex: 'LIG.F3.0F.W1', ops: [atoms_1.r64, [atoms_1.xmm, atoms_1.m]], s: atoms_1.S.Q, mod: atoms_1.M.X64 },
    ], cvttpd2dq: [{ o: 0x660FE6, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vcvttpd2dq: [{ o: 0xE6, ext: [consts_1.EXT.AVX] },
        { vex: '128.66.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: '256.66.0F.WIG', ops: [atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], cvttpd2pi: [{ o: 0x660F2C, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] }], cvttps2dq: [{ o: 0xF30F5B, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vcvttps2dq: [{ o: 0x5B, ext: [consts_1.EXT.AVX] },
        { vex: '128.F3.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: '256.F3.0F.WIG', ops: [atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], cvttps2pi: [{ o: 0x0F2C, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] }], cvttsd2si: [{ o: 0x0F2C, pfx: [0xF2], ext: [consts_1.EXT.SSE2] },
        { ops: [atoms_1.r32, [atoms_1.xmm, atoms_1.m]], s: atoms_1.S.D },
        { ops: [atoms_1.r64, [atoms_1.xmm, atoms_1.m]], s: atoms_1.S.Q, mod: atoms_1.M.X64 },
    ], vcvttsd2si: [{ o: 0x2C, ext: [consts_1.EXT.AVX] },
        { vex: 'LIG.F2.0F.W0', ops: [atoms_1.r32, [atoms_1.xmm, atoms_1.m]], s: atoms_1.S.D },
        { vex: 'LIG.F2.0F.W1', ops: [atoms_1.r64, [atoms_1.xmm, atoms_1.m]], s: atoms_1.S.Q, mod: atoms_1.M.X64 },
    ], cvttss2si: [{ o: 0x0F2C, pfx: [0xF3], ext: [consts_1.EXT.SSE] },
        { ops: [atoms_1.r32, [atoms_1.xmm, atoms_1.m]], s: atoms_1.S.D },
        { ops: [atoms_1.r64, [atoms_1.xmm, atoms_1.m]], s: atoms_1.S.Q, mod: atoms_1.M.X64 },
    ], vcvttss2si: [{ o: 0x2C, ext: [consts_1.EXT.AVX] },
        { vex: 'LIG.F3.0F.W0', ops: [atoms_1.r32, [atoms_1.xmm, atoms_1.m]], s: atoms_1.S.D },
        { vex: 'LIG.F3.0F.W1', ops: [atoms_1.r64, [atoms_1.xmm, atoms_1.m]], s: atoms_1.S.Q, mod: atoms_1.M.X64 },
    ], daa: [{ o: 0x27, mod: atoms_1.M.OLD }], das: [{ o: 0x2F, mod: atoms_1.M.OLD }], divpd: [{ o: 0x660F5E, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vdivpd: [{ o: 0x5E, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.66.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: 'NDS.256.66.0F.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], divps: [{ o: 0x0F5E, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE] }], vdivps: [{ o: 0x5E, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: 'NDS.256.0F.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], divsd: [{ o: 0xF20F5E, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vdivsd: [{ o: 0x5E, en: 'rvm', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: 'NDS.LIG.F2.0F.WIG', ext: [consts_1.EXT.AVX] },
        { evex: 'NDS.LIG.F2.0F.W1', ext: [consts_1.EXT.AVX512F] },
    ], divss: [{ o: 0xF30F5E, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE] }], vdivss: [{ o: 0x5E, en: 'rvm', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: 'NDS.LIG.F3.0F.WIG', ext: [consts_1.EXT.AVX] },
    ], dppd: [{ o: 0x0F3A41, pfx: [0x66], ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8], ext: [consts_1.EXT.SSE4_1] }], vdppd: [{ o: 0x41, vex: 'NDS.128.66.0F3A.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8], ext: [consts_1.EXT.AVX] }], dpps: [{ o: 0x0F3A40, pfx: [0x66], ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8], ext: [consts_1.EXT.SSE4_1] }], vdpps: [{ o: 0x40, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.66.0F3A.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8] },
        { vex: 'NDS.256.66.0F3A.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m], atoms_1.imm8] },
    ], emms: [{ o: 0x0F77 }], extractps: [{ o: 0x0F3A17, pfx: [0x66], en: 'mr', ops: [atoms_1.r32, atoms_1.xmm, atoms_1.imm8], s: atoms_1.S.D, ext: [consts_1.EXT.SSE4_1] }], vextractps: [{ o: 0x17, en: 'mr', vex: '128.66.0F3A.WIG', ops: [atoms_1.rm32, atoms_1.xmm, atoms_1.imm8], s: atoms_1.S.Q, ext: [consts_1.EXT.AVX] }], f2xm1: [{ o: 0xD9F0 }], fabs: [{ o: 0xD9E1 }], fadd: [{},
        { o: 0xD8, or: 0, ops: [atoms_1.m], s: atoms_1.S.D },
        { o: 0xDC, or: 0, ops: [atoms_1.m], s: atoms_1.S.Q },
        { o: 0xD8, ops: [o.st(0), atoms_1.st] },
        { o: 0xDC, ops: [atoms_1.st, o.st(0)] },
    ], faddp: [{},
        { o: 0xDE, ops: [atoms_1.st, o.st(0)] },
        { o: 0xDEC1 },
    ], fiadd: [{ or: 0 },
        { o: 0xDA, ops: [atoms_1.m], s: atoms_1.S.D },
        { o: 0xDE, ops: [atoms_1.m], s: atoms_1.S.W },
    ], fbld: [{ o: 0xDF, or: 4, ops: [atoms_1.m] }], fbstp: [{ o: 0xDF, or: 6, ops: [atoms_1.m] }], fchs: [{ o: 0xD9E0 }], fclex: [{ o: 0x9BDBE2 }], fnclex: [{ o: 0xDBE2 }], fcmovb: [{ o: 0xDA, or: 0, ops: [atoms_1.st] }], fcmove: [{ o: 0xDA, or: 1, ops: [atoms_1.st] }], fcmovbe: [{ o: 0xDA, or: 2, ops: [atoms_1.st] }], fcmovu: [{ o: 0xDA, or: 3, ops: [atoms_1.st] }], fcmovnb: [{ o: 0xDB, or: 0, ops: [atoms_1.st] }], fcmovne: [{ o: 0xDB, or: 1, ops: [atoms_1.st] }], fcmovnbe: [{ o: 0xDB, or: 2, ops: [atoms_1.st] }], fcmovnu: [{ o: 0xDB, or: 3, ops: [atoms_1.st] }], fcom: [{ or: 2 },
        { o: 0xD8, ops: [atoms_1.m], s: atoms_1.S.D },
        { o: 0xDC, ops: [atoms_1.m], s: atoms_1.S.Q },
        { o: 0xD8, ops: [atoms_1.st] },
        { o: 0xD8D1 },
    ], fcomp: [{ or: 3 },
        { o: 0xD8, ops: [atoms_1.m], s: atoms_1.S.D },
        { o: 0xDC, ops: [atoms_1.m], s: atoms_1.S.Q },
        { o: 0xD8, ops: [atoms_1.st] },
        { o: 0xD8D9 },
    ], fcompp: [{ o: 0xDED9 }], fcomi: [{ o: 0xDB, or: 6, ops: [atoms_1.st] }], fcomip: [{ o: 0xDF, or: 6, ops: [atoms_1.st] }], fucomi: [{ o: 0xDB, or: 5, ops: [atoms_1.st] }], fucomip: [{ o: 0xDF, or: 5, ops: [atoms_1.st] }], fcos: [{ o: 0xD9FF }], fdecstp: [{ o: 0xD9F6 }], fdiv: [{},
        { o: 0xD8, or: 6, ops: [atoms_1.m], s: atoms_1.S.D },
        { o: 0xDC, or: 6, ops: [atoms_1.m], s: atoms_1.S.Q },
        { o: 0xD8, i: 0xF0, ops: [o.st(0), atoms_1.st] },
        { o: 0xDC, i: 0xF8, ops: [atoms_1.st, o.st(0)] },
    ], fdivp: [{},
        { o: 0xDE, i: 0xF8, ops: [atoms_1.st, o.st(0)] },
        { o: 0xDEF9 },
    ], fidiv: [{ or: 6 },
        { o: 0xDA, ops: [atoms_1.m], s: atoms_1.S.D },
        { o: 0xDE, ops: [atoms_1.m], s: atoms_1.S.W },
    ], fdivr: [{},
        { o: 0xD8, or: 7, ops: [atoms_1.m], s: atoms_1.S.D },
        { o: 0xDC, or: 7, ops: [atoms_1.m], s: atoms_1.S.Q },
        { o: 0xD8, i: 0xF8, ops: [o.st(0), atoms_1.st] },
        { o: 0xDC, i: 0xF0, ops: [atoms_1.st, o.st(0)] },
    ], fdivrp: [{ o: 0xDE },
        { i: 0xF0, ops: [atoms_1.st, o.st(0)] },
        { i: 0xF1 },
    ], fidivr: [{ or: 7 },
        { o: 0xDA, ops: [atoms_1.m], s: atoms_1.S.D },
        { o: 0xDE, ops: [atoms_1.m], s: atoms_1.S.W },
    ], ffree: [{ o: 0xDD, i: 0xC0, ops: [atoms_1.st] }], ficom: [{ or: 2 },
        { o: 0xDE, ops: [atoms_1.m], s: atoms_1.S.W },
        { o: 0xDA, ops: [atoms_1.m], s: atoms_1.S.D },
    ], ficomp: [{ or: 3 },
        { o: 0xDE, ops: [atoms_1.m], s: atoms_1.S.W },
        { o: 0xDA, ops: [atoms_1.m], s: atoms_1.S.D },
    ], fild: [{},
        { o: 0xDF, or: 0, ops: [atoms_1.m], s: atoms_1.S.W },
        { o: 0xDB, or: 0, ops: [atoms_1.m], s: atoms_1.S.D },
        { o: 0xDF, or: 5, ops: [atoms_1.m], s: atoms_1.S.Q },
    ], fincstp: [{ o: 0xD9F7 }], finit: [{ o: 0x9BDBE3 }], fninit: [{ o: 0xDBE3 }], fist: [{ or: 2, ops: [atoms_1.m] },
        { o: 0xDF, s: atoms_1.S.W },
        { o: 0xDB, s: atoms_1.S.D },
    ], fistp: [{ ops: [atoms_1.m] },
        { o: 0xDF, or: 3, s: atoms_1.S.W },
        { o: 0xDB, or: 3, s: atoms_1.S.D },
        { o: 0xDF, or: 7, s: atoms_1.S.Q },
    ], fisttp: [{ or: 1, ops: [atoms_1.m] },
        { o: 0xDF, s: atoms_1.S.W },
        { o: 0xDB, s: atoms_1.S.D },
        { o: 0xDD, s: atoms_1.S.Q },
    ], fld: [{},
        { o: 0xD9, or: 0, ops: [atoms_1.m], s: atoms_1.S.D },
        { o: 0xDD, or: 0, ops: [atoms_1.m], s: atoms_1.S.Q },
        { o: 0xDB, or: 5, ops: [atoms_1.m], s: atoms_1.S.T },
        { o: 0xD9, i: 0xC0, ops: [atoms_1.st] },
    ], fld1: [{ o: 0xD9E8 }], fldl2t: [{ o: 0xD9E9 }], fldl2e: [{ o: 0xD9EA }], fldpi: [{ o: 0xD9EB }], fldlg2: [{ o: 0xD9EC }], fldln2: [{ o: 0xD9ED }], fldz: [{ o: 0xD9EE }], fldcw: [{ o: 0xD9, or: 5, ops: [atoms_1.m], s: atoms_1.S.W }], fldenv: [{ o: 0xD9, or: 4, ops: [atoms_1.m] }], fmul: [{},
        { o: 0xD8, or: 1, ops: [atoms_1.m], s: atoms_1.S.D },
        { o: 0xDC, or: 1, ops: [atoms_1.m], s: atoms_1.S.Q },
        { o: 0xD8, i: 0xC8, ops: [o.st(0), atoms_1.st] },
        { o: 0xDC, i: 0xC8, ops: [atoms_1.st, o.st(0)] },
    ], fmulp: [{},
        { o: 0xDE, i: 0xC8, ops: [atoms_1.st, o.st(0)] },
        { o: 0xDEC9 },
    ], fimul: [{ or: 1 },
        { o: 0xDA, ops: [atoms_1.m], s: atoms_1.S.D },
        { o: 0xDE, ops: [atoms_1.m], s: atoms_1.S.Q },
    ], fnop: [{ o: 0xD9D0 }], fpatan: [{ o: 0xD9F3 }], fprem: [{ o: 0xD9F8 }], fprem1: [{ o: 0xD9F5 }], fptan: [{ o: 0xD9F2 }], frndint: [{ o: 0xD9FC }], frstor: [{ o: 0xDD, or: 4, ops: [atoms_1.m] }], fsave: [{ o: 0x9BDD, or: 6, ops: [atoms_1.m] }], fnsave: [{ o: 0xDD, or: 6, ops: [atoms_1.m] }], fscale: [{ o: 0xD9FD }], fsin: [{ o: 0xD9FE }], fsincos: [{ o: 0xD9FB }], fsqrt: [{ o: 0xD9FA }], fst: [{},
        { o: 0xD9, or: 2, ops: [atoms_1.m], s: atoms_1.S.D },
        { o: 0xDD, or: 2, ops: [atoms_1.m], s: atoms_1.S.Q },
        { o: 0xDD, i: 0xD0, ops: [atoms_1.st] },
    ], fstp: [{},
        { o: 0xD9, or: 3, ops: [atoms_1.m], s: atoms_1.S.D },
        { o: 0xDD, or: 3, ops: [atoms_1.m], s: atoms_1.S.Q },
        { o: 0xDB, or: 7, ops: [atoms_1.m], s: atoms_1.S.T },
        { o: 0xDD, i: 0xD8, ops: [atoms_1.st] },
    ], fstcw: [{ o: 0x9BD9, or: 7, ops: [atoms_1.m], s: atoms_1.S.W }], fnstcw: [{ o: 0xD9, or: 7, ops: [atoms_1.m], s: atoms_1.S.W }], fstenv: [{ o: 0x9BD9, or: 6, ops: [atoms_1.m] }], fnstenv: [{ o: 0xD9, or: 6, ops: [atoms_1.m] }], fstsw: [{},
        { o: 0x9BDD, or: 7, ops: [atoms_1.m], s: atoms_1.S.W },
        { o: 0x9BDFE0, mr: false, ops: [o.ax] },
    ], fnstsw: [{},
        { o: 0xDD, or: 7, ops: [atoms_1.m], s: atoms_1.S.W },
        { o: 0xDFE0, mr: false, ops: [o.ax] },
    ], fsub: [{},
        { o: 0xD8, or: 4, ops: [atoms_1.m], s: atoms_1.S.D },
        { o: 0xDC, or: 4, ops: [atoms_1.m], s: atoms_1.S.Q },
        { o: 0xD8, i: 0xE0, ops: [o.st(0), atoms_1.st] },
        { o: 0xDC, i: 0xE8, ops: [atoms_1.st, o.st(0)] },
    ], fsubp: [{},
        { o: 0xDE, i: 0xE8, ops: [atoms_1.st, o.st(0)] },
        { o: 0xDEE9 },
    ], fisub: [{ or: 4 },
        { o: 0xDA, ops: [atoms_1.m], s: atoms_1.S.D },
        { o: 0xDE, ops: [atoms_1.m], s: atoms_1.S.W },
    ], fsubr: [{},
        { o: 0xD8, or: 5, ops: [atoms_1.m], s: atoms_1.S.D },
        { o: 0xDC, or: 5, ops: [atoms_1.m], s: atoms_1.S.Q },
        { o: 0xD8, i: 0xE8, ops: [o.st(0), atoms_1.st] },
        { o: 0xDC, i: 0xE0, ops: [atoms_1.st, o.st(0)] },
    ], fsubrp: [{},
        { o: 0xDE, i: 0xE0, ops: [atoms_1.st, o.st(0)] },
        { o: 0xDEE1 },
    ], fisubr: [{ or: 5 },
        { o: 0xDA, ops: [atoms_1.m], s: atoms_1.S.D },
        { o: 0xDE, ops: [atoms_1.m], s: atoms_1.S.W },
    ], ftst: [{ o: 0xD9E4 }], fucom: [{ o: 0xDD, i: 0xE0, ops: [atoms_1.st] }], fucomp: [{ o: 0xDD, i: 0xE8, ops: [atoms_1.st] }], fucompp: [{ o: 0xDAE9 }], fxam: [{ o: 0xD9E5 }], fxch: [{ o: 0xD9, i: 0xC8, ops: [atoms_1.st] }], fxrstor: [{ o: 0x0FAE, or: 1, ops: [atoms_1.m], s: 512 }], fxrstor64: [{ o: 0x0FAE, or: 1, ops: [atoms_1.m], s: 512, mod: atoms_1.M.X64 }], fxsave: [{ o: 0x0FAE, or: 0, ops: [atoms_1.m], s: 512 }], fxsave64: [{ o: 0x0FAE, or: 0, ops: [atoms_1.m], s: 512, mod: atoms_1.M.X64 }], fxtract: [{ o: 0xD9F4 }], fyl2x: [{ o: 0xD9F1 }], fyl2xp1: [{ o: 0xD9F9 }], haddpd: [{ o: 0x660F7C, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE3] }], vhaddpd: [{ o: 0x7C, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.66.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: 'NDS.256.66.0F.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], haddps: [{ o: 0xF20F7C, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE3] }], vhaddps: [{ o: 0x7C, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.F2.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: 'NDS.256.F2.0F.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], hlt: [{ o: 0xF4 }], hsubpd: [{ o: 0x660F7D, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE3] }], vhsubpd: [{ o: 0x7D, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.66.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: 'NDS.256.66.0F.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], hsubps: [{ o: 0xF20F7D, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE3] }], vhsubps: [{ o: 0x7D, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.F2.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: 'NDS.256.F2.0F.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], insertps: [{ o: 0x0F3A21, pfx: [0x66], ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8], ext: [consts_1.EXT.SSE4_1] }], vinsertps: [{ o: 0x21, vex: 'NDS.128.66.0F3A.WIG', en: 'rvm', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8], ext: [consts_1.EXT.AVX] }], invd: [{ o: 0x0F08 }], invlpg: [{ o: 0x0F01, or: 7, ops: [atoms_1.m] }], invpcid: [{ o: 0x3882, pfx: [0x66, 0x0F], ext: [consts_1.EXT.INVPCID] },
        { ops: [atoms_1.r32, atoms_1.m], mod: atoms_1.M.X32 },
        { ops: [atoms_1.r64, atoms_1.m], mod: atoms_1.M.X64 },
    ], lahf: [{ o: 0x9F, mod: atoms_1.M.COMP | atoms_1.M.LEG }], lar: [{ o: 0x0F02 },
        { ops: [atoms_1.r16, atoms_1.rm16] },
        { ops: [atoms_1.r, atoms_1.rm32] },
    ], lddqu: [{ o: 0xF20FF0, ops: [atoms_1.xmm, atoms_1.m], ext: [consts_1.EXT.SSE3] }], vlddqu: [{ o: 0xF0, ext: [consts_1.EXT.AVX] },
        { vex: '128.F2.0F.WIG', ops: [atoms_1.xmm, atoms_1.m] },
        { vex: '256.F2.0F.WIG', ops: [atoms_1.ymm, atoms_1.m] },
    ], ldmxcsr: [{ o: 0x0FAE, or: 2, ops: [atoms_1.m], s: atoms_1.S.D, ext: atoms_2.ext_sse }], vldmxcsr: [{ o: 0xAE, or: 2, vex: 'VEX.LZ.0F.WIG', ops: [atoms_1.m], ext: atoms_2.ext_avx }], lfence: [{ o: 0x0FAEE8 }], lgdt: [{ o: 0x0F01, or: 2 },
        { ops: [atoms_1.m] },
    ], lidt: [{ o: 0x0F01, or: 3 },
        { ops: [atoms_1.m] },
    ], lldt: [{ o: 0x0F00, or: 2, ops: [atoms_1.rm16] }], lmsw: [{ o: 0x0F01, or: 6, ops: [atoms_1.rm16] }], lock: [{ o: 0xF0 }], lsl: [{ o: 0x0F03 },
        { ops: [atoms_1.r16, atoms_1.rm16] },
        { ops: [atoms_1.r32, atoms_1.rm32] },
        { ops: [atoms_1.r64, atoms_1.rm32], s: atoms_1.S.Q },
    ], ltr: [{ o: 0x0F00, or: 3, ops: [atoms_1.rm16] }], lzcnt: [{ o: 0x0FBD, pfx: [0xF3], ext: [consts_1.EXT.LZCNT] },
        { ops: [atoms_1.r16, atoms_1.rm16] },
        { ops: [atoms_1.r32, atoms_1.rm32] },
        { ops: [atoms_1.r64, atoms_1.rm64] },
    ], maskmovdqu: [{ o: 0x660FF7, ops: [atoms_1.xmm, atoms_1.xmm], ext: [consts_1.EXT.SSE2] }], vmaskmovdqu: [{ o: 0xF7, vex: '128.66.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm], ext: [consts_1.EXT.AVX] }], maskmovq: [{ o: 0x0FF7, ops: [atoms_1.mm, atoms_1.mm] }], maxpd: [{ o: 0x660F5F, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vmaxpd: [{ o: 0x5F, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.66.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: 'NDS.256.66.0F.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], maxps: [{ o: 0x0F5F, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE] }], vmaxps: [{ o: 0x5F, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: 'NDS.256.0F.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], maxsd: [{ o: 0xF20F5F, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vmaxsd: [{ o: 0x5F, vex: 'NDS.LIG.F2.0F.WIG', en: 'rvm', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.AVX] }], maxss: [{ o: 0xF30F5F, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE] }], vmaxss: [{ o: 0x5F, vex: 'NDS.LIG.F3.0F.WIG', en: 'rvm', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.AVX] }], mfence: [{ o: 0x0FAEF0 }], minpd: [{ o: 0x660F5D, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vminpd: [{ o: 0x5D, ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.66.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: 'NDS.256.66.0F.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], minps: [{ o: 0x0F5D, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE] }], vminps: [{ o: 0x5D, ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: 'NDS.256.0F.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], minsd: [{ o: 0xF20F5D, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE2] }], vminsd: [{ o: 0x5D, vex: 'NDS.LIG.F2.0F.WIG', en: 'rvm', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.AVX] }], minss: [{ o: 0xF30F5D, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE] }], vminss: [{ o: 0x5D, vex: 'NDS.LIG.F3.0F.WIG', en: 'rvm', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.AVX] }], monitor: [{ o: 0x0F01C8 }], movapd: [{ pfx: [0x66, 0x0F], ext: [consts_1.EXT.SSE2] },
        { o: 0x28, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], dbit: true },
        { o: 0x29, ops: [[atoms_1.xmm, atoms_1.m], atoms_1.xmm], dbit: true, en: 'mr' },
    ], vmovapd: [{ ext: [consts_1.EXT.AVX] },
        { o: 0x28, vex: '128.66.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], dbit: true },
        { o: 0x29, vex: '128.66.0F.WIG', ops: [[atoms_1.xmm, atoms_1.m], atoms_1.xmm], dbit: true, en: 'mr' },
        { o: 0x28, vex: '256.66.0F.WIG', ops: [atoms_1.ymm, [atoms_1.ymm, atoms_1.m]], dbit: true },
        { o: 0x29, vex: '256.66.0F.WIG', ops: [[atoms_1.ymm, atoms_1.m], atoms_1.ymm], dbit: true, en: 'mr' },
    ], movaps: [{ pfx: [0x0F], ext: [consts_1.EXT.SSE] },
        { o: 0x28, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], dbit: true },
        { o: 0x29, ops: [[atoms_1.xmm, atoms_1.m], atoms_1.xmm], dbit: true, en: 'mr' },
    ], vmovaps: [{ ext: [consts_1.EXT.AVX] },
        { o: 0x28, vex: '128.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], dbit: true },
        { o: 0x29, vex: '128.0F.WIG', ops: [[atoms_1.xmm, atoms_1.m], atoms_1.xmm], dbit: true, en: 'mr' },
        { o: 0x28, vex: '256.0F.WIG', ops: [atoms_1.ymm, [atoms_1.ymm, atoms_1.m]], dbit: true },
        { o: 0x29, vex: '256.0F.WIG', ops: [[atoms_1.ymm, atoms_1.m], atoms_1.ymm], dbit: true, en: 'mr' },
    ], movd: [{},
        { o: 0x0F6E, ops: [atoms_1.mm, atoms_1.rm32], s: atoms_1.S.D, ext: [consts_1.EXT.MMX] },
        { o: 0x0F7E, ops: [atoms_1.rm32, atoms_1.mm], s: atoms_1.S.D, ext: [consts_1.EXT.MMX] },
        { o: 0x0F6E, pfx: [0x66], ops: [atoms_1.xmm, atoms_1.rm32], s: atoms_1.S.D, ext: [consts_1.EXT.SSE2] },
        { o: 0x0F7E, pfx: [0x66], ops: [atoms_1.rm32, atoms_1.xmm], s: atoms_1.S.D, ext: [consts_1.EXT.SSE2] },
    ], vmovd: [{ ext: [consts_1.EXT.AVX] },
        { o: 0x6E, vex: '128.66.0F.W0', ops: [atoms_1.xmm, atoms_1.rm32], s: atoms_1.S.D },
        { o: 0x7E, vex: '128.66.0F.W0', ops: [atoms_1.rm32, atoms_1.xmm], s: atoms_1.S.D },
    ], movq: [{ mod: atoms_1.M.X64 },
        { o: 0x0F6E, ops: [atoms_1.mm, atoms_1.rm64], s: atoms_1.S.Q, ext: [consts_1.EXT.MMX] },
        { o: 0x0F7E, ops: [atoms_1.rm64, atoms_1.mm], s: atoms_1.S.Q, ext: [consts_1.EXT.MMX] },
        { o: 0x0F6E, pfx: [0x66], ops: [atoms_1.xmm, atoms_1.rm64], s: atoms_1.S.Q, ext: [consts_1.EXT.SSE2] },
        { o: 0x0F7E, pfx: [0x66], ops: [atoms_1.rm64, atoms_1.xmm], s: atoms_1.S.Q, ext: [consts_1.EXT.SSE2] },
        { o: 0x0F6F, ops: [atoms_1.mm, [atoms_1.mm, atoms_1.m64]], s: atoms_1.S.Q, ext: atoms_2.ext_mmx },
        { o: 0x0F7F, ops: [[atoms_1.mm, atoms_1.m64], atoms_1.mm], s: atoms_1.S.Q, en: 'mr', ext: atoms_2.ext_mmx },
        { o: 0xF30F7E, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m64]], s: atoms_1.S.Q, ext: atoms_2.ext_sse2 },
        { o: 0x660FD6, ops: [[atoms_1.xmm, atoms_1.m64], atoms_1.xmm], s: atoms_1.S.Q, en: 'mr', ext: atoms_2.ext_sse2 },
    ], vmovq: [{ mod: atoms_1.M.X64, ext: [consts_1.EXT.AVX] },
        { o: 0x6E, vex: '128.66.0F.W1', ops: [atoms_1.xmm, atoms_1.rm64], s: atoms_1.S.Q },
        { o: 0x7E, vex: '128.66.0F.W1', ops: [atoms_1.rm64, atoms_1.xmm], s: atoms_1.S.Q, en: 'mr' },
        { o: 0x7E, vex: '128.F3.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm] },
        { o: 0x7E, vex: '128.F3.0F.WIG', ops: [atoms_1.xmm, atoms_1.m64], s: atoms_1.S.Q },
        { o: 0xD6, vex: '128.66.0F.WIG', ops: [[atoms_1.xmm, atoms_1.m64], atoms_1.xmm], s: atoms_1.S.Q, en: 'mr' },
    ], movddup: [{ o: 0xF20F12, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE3] }], vmovddup: [{ o: 0x12, ext: [consts_1.EXT.AVX] },
        { vex: '128.F2.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: '256.F2.0F.WIG', ops: [atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], movdqa: [{ pfx: [0x66, 0x0F], ext: [consts_1.EXT.SSE2] },
        { o: 0x6F, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { o: 0x7F, ops: [[atoms_1.xmm, atoms_1.m], atoms_1.xmm], en: 'mr' },
    ], vmovdqa: [{ ext: [consts_1.EXT.AVX] },
        { o: 0x6F, vex: '128.66.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { o: 0x7F, vex: '128.66.0F.WIG', ops: [[atoms_1.xmm, atoms_1.m], atoms_1.xmm], en: 'mr' },
        { o: 0x6F, vex: '256.66.0F.WIG', ops: [atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
        { o: 0x7F, vex: '256.66.0F.WIG', ops: [[atoms_1.ymm, atoms_1.m], atoms_1.ymm], en: 'mr' },
    ], movdqu: [{ pfx: [0xF3, 0x0F], ext: [consts_1.EXT.SSE2] },
        { o: 0x6F, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { o: 0x7F, ops: [[atoms_1.xmm, atoms_1.m], atoms_1.xmm], en: 'mr' },
    ], vmovdqu: [{ ext: [consts_1.EXT.AVX] },
        { o: 0x6F, vex: '128.F3.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { o: 0x7F, vex: '128.F3.0F.WIG', ops: [[atoms_1.xmm, atoms_1.m], atoms_1.xmm], en: 'mr' },
        { o: 0x6F, vex: '256.F3.0F.WIG', ops: [atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
        { o: 0x7F, vex: '256.F3.0F.WIG', ops: [[atoms_1.ymm, atoms_1.m], atoms_1.ymm], en: 'mr' },
    ], movdq2q: [{ o: 0xF20FD6, ops: [atoms_1.mm, atoms_1.xmm] }], movhlps: [{ o: 0x0F12, ops: [atoms_1.xmm, atoms_1.xmm], ext: [consts_1.EXT.SSE] }], vmovhlps: [{ o: 0x12, vex: 'NDS.128.0F.WIG', en: 'rvm', ops: [atoms_1.xmm, atoms_1.xmm, atoms_1.xmm], ext: [consts_1.EXT.AVX] }], movhpd: [{ pfx: [0x66, 0x0F], ext: [consts_1.EXT.SSE2] },
        { o: 0x16, ops: [atoms_1.xmm, atoms_1.m64], dbit: true },
        { o: 0x17, ops: [atoms_1.m64, atoms_1.xmm], dbit: true, en: 'mr' },
    ], vmovhpd: [{ ext: [consts_1.EXT.AVX] },
        { o: 0x16, vex: 'NDS.128.66.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, atoms_1.m64], en: 'rvm' },
        { o: 0x17, vex: '128.66.0F.WIG', ops: [atoms_1.m64, atoms_1.xmm], en: 'mr' },
    ], movhps: [{ pfx: [0x0F], ext: [consts_1.EXT.SSE] },
        { o: 0x16, ops: [atoms_1.xmm, atoms_1.m64], dbit: true },
        { o: 0x17, ops: [atoms_1.m64, atoms_1.xmm], dbit: true, en: 'mr' },
    ], vmovhps: [{ ext: [consts_1.EXT.AVX] },
        { o: 0x16, vex: 'NDS.128.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, atoms_1.m64], en: 'rvm' },
        { o: 0x17, vex: '128.0F.WIG', ops: [atoms_1.m64, atoms_1.xmm], en: 'mr' },
    ], movlhps: [{ o: 0x0F16, ops: [atoms_1.xmm, atoms_1.xmm], ext: [consts_1.EXT.SSE] }], vmovlhps: [{ o: 0x16, vex: 'NDS.128.0F.WIG', en: 'rvm', ops: [atoms_1.xmm, atoms_1.xmm, atoms_1.xmm], ext: [consts_1.EXT.AVX] }], movlpd: [{ pfx: [0x66, 0x0F], ext: [consts_1.EXT.SSE2] },
        { o: 0x12, ops: [atoms_1.xmm, atoms_1.m64], dbit: true },
        { o: 0x13, ops: [atoms_1.m64, atoms_1.xmm], dbit: true, en: 'mr' },
    ], vmovlpd: [{ ext: [consts_1.EXT.AVX] },
        { o: 0x12, vex: 'NDS.128.66.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, atoms_1.m64], en: 'rvm' },
        { o: 0x13, vex: '128.66.0F.WIG', ops: [atoms_1.m64, atoms_1.xmm], en: 'mr' },
    ], movlps: [{ pfx: [0x0F], ext: [consts_1.EXT.SSE] },
        { o: 0x12, ops: [atoms_1.xmm, atoms_1.m64], dbit: true },
        { o: 0x13, ops: [atoms_1.m64, atoms_1.xmm], dbit: true, en: 'mr' },
    ], vmovlps: [{ ext: [consts_1.EXT.AVX] },
        { o: 0x12, vex: 'NDS.128.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, atoms_1.m64], en: 'rvm' },
        { o: 0x13, vex: '128.0F.WIG', ops: [atoms_1.m64, atoms_1.xmm], en: 'mr' },
    ], movmskpd: [{ o: 0x660F50, ops: [atoms_1.r, atoms_1.xmm], ext: [consts_1.EXT.SSE2] }], vmovmskpd: [{ o: 0x50, ext: [consts_1.EXT.AVX] },
        { vex: '128.66.0F.WIG', ops: [atoms_1.r, atoms_1.xmm] },
        { vex: '256.66.0F.WIG', ops: [atoms_1.r, atoms_1.ymm] },
    ], movmskps: [{ o: 0x0F50, ops: [atoms_1.r, atoms_1.xmm], ext: [consts_1.EXT.SSE] }], vmovmskps: [{ o: 0x50, ext: [consts_1.EXT.AVX] },
        { vex: '128.0F.WIG', ops: [atoms_1.r, atoms_1.xmm] },
        { vex: '256.0F.WIG', ops: [atoms_1.r, atoms_1.ymm] },
    ], movntdqa: [{ o: 0x382A, pfx: [0x66, 0x0F], ops: [atoms_1.xmm, atoms_1.m], ext: [consts_1.EXT.SSE4_1] }], vmovntdqa: [{ o: 0x2A },
        { vex: '128.66.0F38.WIG', ops: [atoms_1.xmm, atoms_1.m], ext: [consts_1.EXT.AVX] },
        { vex: '256.66.0F38.WIG', ops: [atoms_1.ymm, atoms_1.m], ext: [consts_1.EXT.AVX2] },
    ], movntdq: [{ o: 0xE7, pfx: [0x66, 0x0F], en: 'mr', ops: [atoms_1.m128, atoms_1.xmm], ext: [consts_1.EXT.SSE2] }], vmovntdq: [{ o: 0xE7, ext: [consts_1.EXT.AVX] },
        { vex: '128.66.0F.WIG', en: 'mr', ops: [atoms_1.m, atoms_1.xmm] },
        { vex: '256.66.0F.WIG', en: 'mr', ops: [atoms_1.m, atoms_1.ymm] },
    ], movnti: [{ o: 0x0FC3, en: 'mr' },
        { ops: [atoms_1.m32, atoms_1.r32] },
        { ops: [atoms_1.m64, atoms_1.r64] },
    ], movntpd: [{ o: 0x2B, pfx: [0x66, 0x0F], en: 'mr', ops: [atoms_1.m128, atoms_1.xmm], ext: [consts_1.EXT.SSE2] }], vmovntpd: [{ o: 0x2B, ext: [consts_1.EXT.AVX] },
        { vex: '128.66.0F.WIG', en: 'mr', ops: [atoms_1.m, atoms_1.xmm] },
        { vex: '256.66.0F.WIG', en: 'mr', ops: [atoms_1.m, atoms_1.ymm] },
    ], movntps: [{ o: 0x2B, pfx: [0x0F], en: 'mr', ops: [atoms_1.m, atoms_1.xmm], ext: [consts_1.EXT.SSE] }], vmovntps: [{ o: 0x2B, en: 'mr', ext: [consts_1.EXT.AVX] },
        { vex: '128.0F.WIG', ops: [atoms_1.m, atoms_1.xmm] },
        { vex: '256.0F.WIG', ops: [atoms_1.m, atoms_1.ymm] },
    ], movntq: [{ o: 0x0FE7, ops: [atoms_1.m64, atoms_1.mm], en: 'mr' }], movq2dq: [{ o: 0xF30FD6, ops: [atoms_1.xmm, atoms_1.mm] }], movsd: [{ pfx: [0xF2, 0x0F], ext: [consts_1.EXT.SSE2] },
        { o: 0x10, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m64]], dbit: true },
        { o: 0x11, ops: [[atoms_1.xmm, atoms_1.m64], atoms_1.xmm], dbit: true, en: 'mr' },
    ], vmovsd: [{ ext: [consts_1.EXT.AVX] },
        { o: 0x10, vex: 'NDS.LIG.F2.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, atoms_1.xmm], en: 'rvm' },
        { o: 0x10, vex: 'LIG.F2.0F.WIG', ops: [atoms_1.xmm, atoms_1.m64], en: 'rm' },
        { o: 0x11, vex: 'NDS.LIG.F2.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, atoms_1.xmm], en: 'mvr' },
        { o: 0x11, vex: 'LIG.F2.0F.WIG', ops: [atoms_1.m64, atoms_1.xmm], en: 'mr' },
    ], movshdup: [{ o: 0xF30F16, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE3] }], vmovshdup: [{ o: 0x16, ext: [consts_1.EXT.AVX] },
        { vex: '128.F3.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: '256.F3.0F.WIG', ops: [atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], movsldup: [{ o: 0xF30F12, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE3] }], vmovsldup: [{ o: 0x12, ext: [consts_1.EXT.AVX] },
        { vex: '128.F3.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: '256.F3.0F.WIG', ops: [atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], movss: [{ ext: [consts_1.EXT.SSE] },
        { o: 0xF30F10, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { o: 0xF30F11, ops: [[atoms_1.xmm, atoms_1.m], atoms_1.xmm], en: 'mr' },
    ], vmovss: [{ ext: [consts_1.EXT.AVX] },
        { o: 0x10, vex: 'NDS.LIG.F3.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, atoms_1.xmm], en: 'rvm' },
        { o: 0x10, vex: 'LIG.F3.0F.WIG', ops: [atoms_1.xmm, atoms_1.m] },
        { o: 0x11, vex: 'NDS.LIG.F3.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, atoms_1.xmm], en: 'mvr' },
        { o: 0x11, vex: 'LIG.F3.0F.WIG', ops: [atoms_1.m, atoms_1.xmm], en: 'mr' },
    ], movupd: [{ ext: [consts_1.EXT.SSE2] },
        { o: 0x660F10, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { o: 0x660F11, ops: [[atoms_1.xmm, atoms_1.m], atoms_1.xmm], en: 'mr' },
    ], vmovupd: [{ ext: [consts_1.EXT.AVX] },
        { o: 0x10, vex: '128.66.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { o: 0x10, vex: '256.66.0F.WIG', ops: [atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
        { o: 0x11, vex: '128.66.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], en: 'mr' },
        { o: 0x11, vex: '256.66.0F.WIG', ops: [atoms_1.ymm, [atoms_1.ymm, atoms_1.m]], en: 'mr' },
    ], movups: [{ ext: [consts_1.EXT.SSE] },
        { o: 0x0F10, ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { o: 0x0F11, ops: [[atoms_1.xmm, atoms_1.m], atoms_1.xmm], en: 'mr' },
    ], vmovups: [{ ext: [consts_1.EXT.AVX] },
        { o: 0x10, vex: '128.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { o: 0x10, vex: '256.0F.WIG', ops: [atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
        { o: 0x11, vex: '128.0F.WIG', ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], en: 'mr' },
        { o: 0x11, vex: '256.0F.WIG', ops: [atoms_1.ymm, [atoms_1.ymm, atoms_1.m]], en: 'mr' },
    ], mpsadbw: [{ o: 0x42, pfx: [0x66, 0x0F, 0x3A], ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8], ext: [consts_1.EXT.SSE4_1] }], vmpsadbw: [{ o: 0x42, en: 'rvm' },
        { ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m], atoms_1.imm8], ext: [consts_1.EXT.AVX] },
        { ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m], atoms_1.imm8], ext: [consts_1.EXT.AVX2] },
    ], mulps: [{ o: 0x59, pfx: [0x0F], ops: [atoms_1.xmm, [atoms_1.xmm, atoms_1.m]], ext: [consts_1.EXT.SSE] }], vmulps: [{ o: 0x59, ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.0F.WIG', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] },
        { vex: 'NDS.256.0F.WIG', ops: [atoms_1.ymm, atoms_1.ymm, [atoms_1.ymm, atoms_1.m]] },
    ], mulsd: [{ o: 0x59, pfx: [0xF2, 0x0F], ops: atoms_1.xmm_xmmm, ext: [consts_1.EXT.SSE2] }], vmulsd: [{ o: 0x59, vex: 'NDS.LIG.F2.0F.WIG', ops: atoms_1.xmm_xmm_xmmm, en: 'rvm', ext: [consts_1.EXT.AVX] }], mulss: [{ o: 0x59, pfx: [0xF3, 0x0F], ops: atoms_1.xmm_xmmm, ext: [consts_1.EXT.SSE] }], vmulss: [{ o: 0x59, vex: 'NDS.LIG.F3.0F.WIG', ops: atoms_1.xmm_xmm_xmmm, en: 'rvm', ext: [consts_1.EXT.AVX] }], mulx: [{ o: 0xF6, en: 'rvm', ext: [consts_1.EXT.BMI2] },
        { vex: 'NDD.LZ.F2.0F38.W0', ops: [atoms_1.r32, atoms_1.r32, atoms_1.rm32] },
        { vex: 'NDD.LZ.F2.0F38.W1', ops: [atoms_1.r64, atoms_1.r64, atoms_1.rm64] },
    ], mwait: [{ o: 0x0F01C9 }], orpd: [{ o: 0x56, pfx: [0x66, 0x0F], ops: atoms_1.xmm_xmmm, ext: [consts_1.EXT.SSE2] }], vorpd: [{ o: 0x56, ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.66.0F.WIG', ops: atoms_1.xmm_xmm_xmmm },
        { vex: 'NDS.256.66.0F.WIG', ops: atoms_1.ymm_ymm_ymmm },
    ], orps: [{ o: 0x56, pfx: [0x0F], ops: atoms_1.xmm_xmmm, ext: [consts_1.EXT.SSE] }], vorps: [{ o: 0x56, en: 'rvm', ext: [consts_1.EXT.AVX] },
        { vex: 'NDS.128.0F.WIG', ops: atoms_1.xmm_xmm_xmmm },
        { vex: 'NDS.256.0F.WIG', ops: atoms_1.ymm_ymm_ymmm },
    ], pabsb: [{ o: 0x1C, ext: [consts_1.EXT.SSSE3] },
        { pfx: [0x0F, 0x38], ops: [atoms_1.mm, [atoms_1.mm, atoms_1.m]] },
        { pfx: [0x66, 0x0F, 0x38], ops: atoms_1.xmm_xmmm },
    ], vpabsb: [{ o: 0x1C },
        { vex: '128.66.0F38.WIG', ops: atoms_1.xmm_xmmm, ext: [consts_1.EXT.AVX] },
        { vex: '256.66.0F38.WIG', ops: atoms_1.ymm_ymmm, ext: [consts_1.EXT.AVX2] },
    ], pabsw: [{ o: 0x1D, ext: [consts_1.EXT.SSSE3] },
        { pfx: [0x0F, 0x38], ops: [atoms_1.mm, [atoms_1.mm, atoms_1.m]] },
        { pfx: [0x66, 0x0F, 0x38], ops: atoms_1.xmm_xmmm },
    ], vpabsw: [{ o: 0x1D },
        { vex: '128.66.0F38.WIG', ops: atoms_1.xmm_xmmm, ext: atoms_2.ext_avx },
        { vex: '256.66.0F38.WIG', ops: atoms_1.ymm_ymmm, ext: atoms_2.ext_avx2 },
    ], pabsd: [{ o: 0x1E, ext: [consts_1.EXT.SSSE3] },
        { pfx: [0x0F, 0x38], ops: [atoms_1.mm, [atoms_1.mm, atoms_1.m]] },
        { pfx: [0x66, 0x0F, 0x38], ops: atoms_1.xmm_xmmm },
    ], vpabsd: [{ o: 0x1E },
        { vex: '128.66.0F38.WIG', ops: atoms_1.xmm_xmmm, ext: atoms_2.ext_avx },
        { vex: '256.66.0F38.WIG', ops: atoms_1.ymm_ymmm, ext: atoms_2.ext_avx2 },
    ], packsswb: [{ o: 0x63 },
        { pfx: [0x0F], ops: [atoms_1.mm, [atoms_1.mm, atoms_1.m]], ext: atoms_2.ext_mmx },
        { pfx: [0x66, 0x0F], ops: atoms_1.xmm_xmmm, ext: atoms_2.ext_sse2 },
    ], vpacksswb: [{ o: 0x63 },
        { vex: 'NDS.128.66.0F.WIG', ops: atoms_1.xmm_xmm_xmmm, ext: atoms_2.ext_avx },
        { vex: 'NDS.256.66.0F.WIG', ops: atoms_1.ymm_ymm_ymmm, ext: atoms_2.ext_avx2 },
    ], packssdw: [{ o: 0x6B, en: atoms_2.rvm },
        { pfx: [0x0F], ops: [atoms_1.mm, [atoms_1.mm, atoms_1.m]], ext: atoms_2.ext_mmx },
        { pfx: [0x66, 0x0F], ops: atoms_1.xmm_xmmm, ext: atoms_2.ext_sse2 },
    ], vpackssdw: [{ o: 0x6B, en: atoms_2.rvm },
        { vex: 'NDS.128.66.0F.WIG', ops: atoms_1.xmm_xmm_xmmm, ext: atoms_2.ext_avx },
        { vex: 'NDS.256.66.0F.WIG', ops: atoms_1.ymm_ymm_ymmm, ext: atoms_2.ext_avx2 },
    ], packusdw: [{ o: 0x2B, pfx: [0x66, 0x0F, 0x38], ops: atoms_1.xmm_xmmm, ext: [consts_1.EXT.SSE4_1] }], vpackusdw: [{ o: 0x2B, en: atoms_2.rvm },
        { vex: 'NDS.128.66.0F38.WIG', ops: atoms_1.xmm_xmm_xmmm, ext: atoms_2.ext_avx },
        { vex: 'NDS.256.66.0F38.WIG', ops: atoms_1.ymm_ymm_ymmm, ext: atoms_2.ext_avx2 },
    ], pause: [{ o: 0xF390 }], mov: [{},
        { o: 0x88, ops: [atoms_1.rm8, atoms_1.r8], en: 'mr', dbit: true },
        { o: 0x8A, ops: [atoms_1.r8, atoms_1.rm8], dbit: true },
        { o: 0x89, ops: [atoms_1.rm16, atoms_1.r16], en: 'mr', dbit: true },
        { o: 0x8B, ops: [atoms_1.r16, atoms_1.rm16], dbit: true },
        { o: 0x89, ops: [atoms_1.rm32, atoms_1.r32], en: 'mr', dbit: true },
        { o: 0x8B, ops: [atoms_1.r32, atoms_1.rm32], dbit: true },
        { o: 0x89, ops: [atoms_1.rm64, atoms_1.r64], en: 'mr', dbit: true },
        { o: 0x8B, ops: [atoms_1.r64, atoms_1.rm64], dbit: true },
        { o: 0x8C, ops: [atoms_1.rm16, atoms_1.sreg], s: atoms_1.S.W },
        { o: 0x8E, ops: [atoms_1.sreg, atoms_1.rm16], s: atoms_1.S.W },
        { o: 0x8C, ops: [atoms_1.rm64, atoms_1.sreg], s: atoms_1.S.W },
        { o: 0x8E, ops: [atoms_1.sreg, atoms_1.rm64], s: atoms_1.S.W },
        { o: 0xB0, r: true, ops: [atoms_1.r8, atoms_1.imm8] },
        { o: 0xB8, r: true, ops: [atoms_1.r16, atoms_1.imm16] },
        { o: 0xB8, r: true, ops: [atoms_1.r32, atoms_1.imm32] },
        { o: 0xB8, r: true, ops: [atoms_1.r64, atoms_1.imm64] },
        { o: 0xC6, or: 0, ops: [atoms_1.rm8, atoms_1.imm8] },
        { o: 0xC7, or: 0, ops: [atoms_1.rm16, atoms_1.imm16] },
        { o: 0xC7, or: 0, ops: [atoms_1.rm32, atoms_1.imm32] },
        { o: 0xC7, or: 0, ops: [atoms_1.rm64, atoms_1.imm32] },
        { o: 0x0F20, ops: [atoms_1.r32, atoms_2.cr0_7], dbit: true, s: atoms_1.S.D, mod: atoms_1.M.COMP | atoms_1.M.LEG },
        { o: 0x0F20, ops: [atoms_1.r64, atoms_2.cr0_7], dbit: true, s: atoms_1.S.Q, mod: atoms_1.M.X64 },
        { o: 0x0F20, or: 0, ops: [atoms_1.r64, o.cr(8)], s: atoms_1.S.Q, mod: atoms_1.M.X64 },
        { o: 0x0F22, ops: [atoms_2.cr0_7, atoms_1.r32], dbit: true, s: atoms_1.S.D, mod: atoms_1.M.COMP | atoms_1.M.LEG },
        { o: 0x0F22, ops: [atoms_2.cr0_7, atoms_1.r64], dbit: true, s: atoms_1.S.Q, mod: atoms_1.M.X64 },
        { o: 0x0F22, or: 0, ops: [o.cr(8), atoms_1.r64], s: atoms_1.S.Q, mod: atoms_1.M.X64 },
        { o: 0x0F21, ops: [atoms_1.r32, atoms_2.dr0_7], dbit: true, s: atoms_1.S.D, mod: atoms_1.M.COMP | atoms_1.M.LEG },
        { o: 0x0F23, ops: [atoms_2.dr0_7, atoms_1.r32], dbit: true, s: atoms_1.S.D, mod: atoms_1.M.COMP | atoms_1.M.LEG },
        { o: 0x0F21, ops: [atoms_1.r64, atoms_2.dr0_7], dbit: true, s: atoms_1.S.Q, mod: atoms_1.M.X64 },
        { o: 0x0F23, ops: [atoms_2.dr0_7, atoms_1.r64], dbit: true, s: atoms_1.S.Q, mod: atoms_1.M.X64 },
    ], movabs: [{},
        { o: 0xA0, ops: [o.al, atoms_1.imm8] },
        { o: 0xA1, ops: [o.ax, atoms_1.imm16] },
        { o: 0xA1, ops: [o.eax, atoms_1.imm32] },
        { o: 0xA1, ops: [o.rax, atoms_1.imm64] },
        { o: 0xA2, ops: [atoms_1.imm8, o.al] },
        { o: 0xA3, ops: [atoms_1.imm16, o.ax] },
        { o: 0xA3, ops: [atoms_1.imm32, o.eax] },
        { o: 0xA3, ops: [atoms_1.imm64, o.rax] },
    ], cmove: tpl_cmovc(0x0F44), cmovz: ['cmove'], cmovne: tpl_cmovc(0x0F45), cmovnz: ['cmovne'], cmova: tpl_cmovc(0x0F47), cmovnbe: ['cmova'], cmovae: tpl_cmovc(0x0F43), cmovnb: ['cmovae'], cmovb: tpl_cmovc(0x0F42), cmovnae: ['cmovb'], cmovbe: tpl_cmovc(0x0F46), cmovna: ['cmovbe'], cmovg: tpl_cmovc(0x0F4F), cmovnle: ['cmovg'], cmovge: tpl_cmovc(0x0F4D), cmovnl: ['cmovge'], cmovl: tpl_cmovc(0x0F4C), cmovnge: ['cmovl'], cmovle: tpl_cmovc(0x0F4E), cmovng: ['cmovle'], cmovc: tpl_cmovc(), cmovnc: tpl_cmovc(0x0F43), cmovo: tpl_cmovc(0x0F40), cmovno: tpl_cmovc(0x0F41), cmovs: tpl_cmovc(0x0F48), cmovns: tpl_cmovc(0x0F4B), cmovp: tpl_cmovc(0x0F4A), cmovpe: ['cmovp'], cmovnp: tpl_cmovc(0x0F4B), cmovpo: ['cmovnp'], xchg: [{},
        { o: 0x90, r: true, ops: [o.ax, atoms_1.r16] },
        { o: 0x90, r: true, ops: [atoms_1.r16, o.ax] },
        { o: 0x90, r: true, ops: [o.eax, atoms_1.r32] },
        { o: 0x90, r: true, ops: [o.rax, atoms_1.r64] },
        { o: 0x90, r: true, ops: [atoms_1.r32, o.eax] },
        { o: 0x90, r: true, ops: [atoms_1.r64, o.rax] },
        { o: 0x86, ops: [atoms_1.rm8, atoms_1.rm8] },
        { o: 0x87, ops: [atoms_1.rm16, atoms_1.rm16] },
        { o: 0x87, ops: [atoms_1.rm32, atoms_1.rm32] },
        { o: 0x87, ops: [atoms_1.rm64, atoms_1.rm64] },
    ], bswap: [{ o: 0x0FC8, r: true },
        { ops: [atoms_1.r32] },
        { ops: [atoms_1.r64] },
    ], xadd: tpl_xadd(0x0FC0), cmpxchg: tpl_xadd(0x0FB0), cmpxchg8b: [{ o: 0x0FC7, or: 1, ops: [atoms_1.m], s: atoms_1.S.Q }], cmpxchg16b: [{ o: 0x0FC7, or: 1, ops: [atoms_1.m], s: atoms_1.S.O }], push: [{ ds: atoms_1.S.Q },
        { o: 0xFF, or: 6, ops: [atoms_1.rm16] },
        { o: 0xFF, or: 6, ops: [atoms_1.rm64] },
        { o: 0x50, r: true, ops: [atoms_1.r16] },
        { o: 0x50, r: true, ops: [atoms_1.r64] },
        { o: 0x6A, ops: [atoms_1.imm8] },
        { o: 0x68, ops: [atoms_1.imm16] },
        { o: 0x68, ops: [atoms_1.imm32] },
        { o: 0x0FA0, ops: [o.fs] },
        { o: 0x0FA8, ops: [o.gs] },
    ], pop: [{ ds: atoms_1.S.Q },
        { o: 0x8F, or: 0, ops: [atoms_1.rm16] },
        { o: 0x8F, or: 0, ops: [atoms_1.rm64] },
        { o: 0x58, r: true, ops: [atoms_1.r16] },
        { o: 0x58, r: true, ops: [atoms_1.r64] },
        { o: 0x0FA1, ops: [o.fs], s: atoms_1.S.W },
        { o: 0x0FA1, ops: [o.fs], s: atoms_1.S.Q },
        { o: 0x0FA9, ops: [o.gs], s: atoms_1.S.W },
        { o: 0x0FA9, ops: [o.gs], s: atoms_1.S.W },
    ], cwd: [{ o: 0x99, s: atoms_1.S.W }], cdq: [{ o: 0x99, s: atoms_1.S.D }], cqo: [{ o: 0x99, s: atoms_1.S.Q }], cbw: [{ o: 0x98, s: atoms_1.S.W }], cwde: [{ o: 0x98, s: atoms_1.S.D }], cdqe: [{ o: 0x98, s: atoms_1.S.Q }], movsx: [{},
        { o: 0x0FBE, ops: [atoms_1.r16, atoms_1.rm8], s: atoms_1.S.W },
        { o: 0x0FBE, ops: [atoms_1.r32, atoms_1.rm8], s: atoms_1.S.D },
        { o: 0x0FBE, ops: [atoms_1.r64, atoms_1.rm8], s: atoms_1.S.Q },
        { o: 0x0FBF, ops: [atoms_1.r32, atoms_1.rm16], s: atoms_1.S.D },
        { o: 0x0FBF, ops: [atoms_1.r64, atoms_1.rm16], s: atoms_1.S.Q },
    ], movsxd: [{ o: 0x63, ops: [atoms_1.r64, atoms_1.rm32], s: atoms_1.S.Q }], movzx: [{},
        { o: 0x0FB6, ops: [atoms_1.r16, atoms_1.rm8], s: atoms_1.S.W },
        { o: 0x0FB6, ops: [atoms_1.r32, atoms_1.rm8], s: atoms_1.S.D },
        { o: 0x0FB6, ops: [atoms_1.r64, atoms_1.rm8], s: atoms_1.S.Q },
        { o: 0x0FB7, ops: [atoms_1.r32, atoms_1.rm16], s: atoms_1.S.D },
        { o: 0x0FB7, ops: [atoms_1.r64, atoms_1.rm16], s: atoms_1.S.Q },
    ], adcx: [{ o: 0x0F38F6, pfx: [0x66], ext: [consts_1.EXT.ADX] },
        { ops: [atoms_1.r32, atoms_1.rm32] },
        { ops: [atoms_1.r64, atoms_1.rm64], mod: atoms_1.M.X64 },
    ], adox: [{ o: 0x0F38F6, pfx: [0xF3], ext: [consts_1.EXT.ADX] },
        { ops: [atoms_1.r32, atoms_1.rm32] },
        { ops: [atoms_1.r64, atoms_1.rm64], mod: atoms_1.M.X64 },
    ], get add() { return lazy('common', 'add'); },
    get adc() { return lazy('common', 'adc'); },
    get sub() { return lazy('common', 'sub'); },
    get sbb() { return lazy('common', 'sbb'); }, imul: [{},
        { o: 0xF6, or: 5, ops: [atoms_1.rm8] },
        { o: 0xF7, or: 5, ops: [atoms_1.rm16] },
        { o: 0xF7, or: 5, ops: [atoms_1.rm32] },
        { o: 0xF7, or: 5, ops: [atoms_1.rm64] },
        { o: 0x0FAF, ops: [atoms_1.r16, atoms_1.rm16] },
        { o: 0x0FAF, ops: [atoms_1.r32, atoms_1.rm32] },
        { o: 0x0FAF, ops: [atoms_1.r64, atoms_1.rm64] },
        { o: 0x6B, ops: [atoms_1.r16, atoms_1.rm16, atoms_1.imm8] },
        { o: 0x6B, ops: [atoms_1.r32, atoms_1.rm32, atoms_1.imm8] },
        { o: 0x6B, ops: [atoms_1.r64, atoms_1.rm64, atoms_1.imm8] },
        { o: 0x69, ops: [atoms_1.r16, atoms_1.rm16, atoms_1.imm16] },
        { o: 0x69, ops: [atoms_1.r32, atoms_1.rm32, atoms_1.imm32] },
        { o: 0x69, ops: [atoms_1.r64, atoms_1.rm64, atoms_1.imm32] },
    ], mul: tpl_not(0xF6, 4, false), idiv: tpl_not(0xF6, 7, false), div: tpl_not(0xF6, 6, false), inc: _inc, dec: _dec, neg: tpl_not(0xF6, 3), get cmp() { return lazy('common', 'cmp'); },
    get and() { return lazy('common', 'and'); },
    get or() { return lazy('common', 'or'); },
    get xor() { return lazy('common', 'xor'); }, not: tpl_not(), get sar() { return lazy('sar', 'sar'); },
    get shr() { return lazy('sar', 'shr'); },
    get shl() { return lazy('sar', 'shl'); }, sal: ['shl'], get shrd() { return lazy('shrd', 'shrd'); },
    get shld() { return lazy('shrd', 'shld'); },
    get ror() { return lazy('sar', 'ror'); },
    get rol() { return lazy('sar', 'rol'); },
    get rcr() { return lazy('sar', 'rcr'); },
    get rcl() { return lazy('sar', 'rcl'); }, bt: tpl_bt(), bts: tpl_bt(0x0FAB, 4), btr: tpl_bt(0x0FB3, 6), btc: tpl_bt(0x0FBB, 7), bsf: tpl_bsf(), bsr: tpl_bsf(0x0FBD), sete: [{ o: 0x0F94, ops: [atoms_1.rm8] }], setz: ['sete'], setne: [{ o: 0x0F95, ops: [atoms_1.rm8] }], setnz: ['setne'], seta: [{ o: 0x0F97, ops: [atoms_1.rm8] }], setnbe: ['seta'], setae: [{ o: 0x0F93, ops: [atoms_1.rm8] }], setnb: ['setae'], setnc: ['setae'], setb: [{ o: 0x0F92, ops: [atoms_1.rm8] }], setnae: ['setb'], setc: ['setb'], setbe: [{ o: 0x0F96, ops: [atoms_1.rm8] }], setna: ['setbe'], setg: [{ o: 0x0F9F, ops: [atoms_1.rm8] }], setnle: ['setg'], setge: [{ o: 0x0F9D, ops: [atoms_1.rm8] }], setnl: ['setge'], setl: [{ o: 0x0F9C, ops: [atoms_1.rm8] }], setnge: ['setl'], setle: [{ o: 0x0F9E, ops: [atoms_1.rm8] }], setng: ['setle'], sets: [{ o: 0x0F98, ops: [atoms_1.rm8] }], setns: [{ o: 0x0F99, ops: [atoms_1.rm8] }], seto: [{ o: 0x0F90, ops: [atoms_1.rm8] }], setno: [{ o: 0x0F91, ops: [atoms_1.rm8] }], setp: [{ o: 0x0F9A, ops: [atoms_1.rm8] }], setpe: ['setp'], setnp: [{ o: 0x0F9B, ops: [atoms_1.rm8] }], setpo: ['setnp'], test: [{},
        { o: 0xA8, ops: [o.al, atoms_1.imm8] },
        { o: 0xA9, ops: [o.ax, atoms_1.imm16] },
        { o: 0xA9, ops: [o.eax, atoms_1.imm32] },
        { o: 0xA9, ops: [o.rax, atoms_1.imm32] },
        { o: 0xF6, or: 0, ops: [atoms_1.rm8, atoms_1.imm8] },
        { o: 0xF7, or: 0, ops: [atoms_1.rm16, atoms_1.imm16] },
        { o: 0xF7, or: 0, ops: [atoms_1.rm32, atoms_1.imm32] },
        { o: 0xF7, or: 0, ops: [atoms_1.rm64, atoms_1.imm32] },
        { o: 0x84, ops: [atoms_1.rm8, atoms_1.r8] },
        { o: 0x85, ops: [atoms_1.rm16, atoms_1.r16] },
        { o: 0x85, ops: [atoms_1.rm32, atoms_1.r32] },
        { o: 0x85, ops: [atoms_1.rm64, atoms_1.r64] },
    ], crc32: [{ pfx: [0xF2] },
        { o: 0x0F38F0, ops: [atoms_1.r32, atoms_1.rm8], s: atoms_1.S.D },
        { o: 0x0F38F1, ops: [atoms_1.r32, atoms_1.rm16], s: atoms_1.S.D },
        { o: 0x0F38F1, ops: [atoms_1.r32, atoms_1.rm32], s: atoms_1.S.D },
        { o: 0x0F38F0, ops: [atoms_1.r64, atoms_1.rm8], s: atoms_1.S.Q },
        { o: 0x0F38F1, ops: [atoms_1.r64, atoms_1.rm64] },
    ], popcnt: [{ pfx: [0xF3] },
        { o: 0x0FB8, ops: [atoms_1.r16, atoms_1.rm16], s: atoms_1.S.W },
        { o: 0x0FB8, ops: [atoms_1.r32, atoms_1.rm32], s: atoms_1.S.D },
        { o: 0x0FB8, ops: [atoms_1.r64, atoms_1.rm64], s: atoms_1.S.Q },
    ], jmp: [{ ds: atoms_1.S.Q },
        { o: 0xEB, ops: [atoms_1.rel8] },
        { o: 0xE9, ops: [atoms_1.rel32] },
        { o: 0xFF, or: 4, ops: [atoms_1.rm64] },
    ], ljmp: [{ ds: atoms_1.S.Q },
        { o: 0xFF, or: 5, ops: [atoms_1.m], s: atoms_1.S.Q },
    ], jecxz: [{ o: 0xE3, ops: [atoms_1.rel8], pfx: [0x67] }], jrcxz: [{ o: 0xE3, ops: [atoms_1.rel8] }], ja: tpl_ja(), jae: tpl_ja(0x73, 0x0F83), jb: tpl_ja(0x72, 0x0F82), jbe: tpl_ja(0x76, 0x0F86), jc: tpl_ja(0x72, 0x0F82), je: tpl_ja(0x74, 0x0F84), jg: tpl_ja(0x7F, 0x0F8F), jge: tpl_ja(0x7D, 0x0F8D), jl: tpl_ja(0x7C, 0x0F8C), jle: tpl_ja(0x7E, 0x0F8E), jna: tpl_ja(0x76, 0x0F86), jnae: tpl_ja(0x72, 0x0F82), jnb: tpl_ja(0x73, 0x0F83), jnbe: tpl_ja(0x77, 0x0F87), jnc: tpl_ja(0x73, 0x0F83), jne: tpl_ja(0x75, 0x0F85), jng: tpl_ja(0x7E, 0x0F8E), jnge: tpl_ja(0x7C, 0x0F8C), jnl: tpl_ja(0x7D, 0x0F8D), jnle: tpl_ja(0x7F, 0x0F8F), jno: tpl_ja(0x71, 0x0F81), jnp: tpl_ja(0x7B, 0x0F8B), jns: tpl_ja(0x79, 0x0F89), jnz: tpl_ja(0x75, 0x0F85), jo: tpl_ja(0x70, 0x0F80), jp: tpl_ja(0x7A, 0x0F8A), jpe: tpl_ja(0x7A, 0x0F8A), jpo: tpl_ja(0x7B, 0x0F8B), js: tpl_ja(0x78, 0x0F88), jz: tpl_ja(0x74, 0x0F84), loop: [{ o: 0xE2, ops: [atoms_1.rel8] }], loope: [{ o: 0xE1, ops: [atoms_1.rel8] }], loopz: ['loope'], loopne: [{ o: 0xE0, ops: [atoms_1.rel8] }], loopnz: ['loopne'], call: [{ ds: atoms_1.S.Q },
        { o: 0xE8, ops: [atoms_1.rel16], mod: atoms_1.M.OLD },
        { o: 0xE8, ops: [atoms_1.rel32] },
        { o: 0xFF, or: 2, ops: [atoms_1.rm16], mod: atoms_1.M.OLD },
        { o: 0xFF, or: 2, ops: [atoms_1.rm32], mod: atoms_1.M.OLD },
        { o: 0xFF, or: 2, ops: [atoms_1.rm64] },
    ], lcall: [{ ds: atoms_1.S.Q },
        { o: 0xFF, or: 3, ops: [atoms_1.m], s: atoms_1.S.D },
    ], ret: [{ ds: atoms_1.S.Q },
        { o: 0xC3 },
        { o: 0xC2, ops: [atoms_1.imm16] }
    ], lret: [{ ds: atoms_1.S.Q },
        { o: 0xCB },
        { o: 0xCA, ops: [atoms_1.imm16] }
    ], iret: [{ o: 0xCF }], iretd: [{ o: 0xCF }], iretq: [{ o: 0xCF, rex: [1, 0, 0, 0] }], movs: tpl_movs(), cmps: tpl_movs(0xA6), scas: tpl_movs(0xAE), lods: tpl_movs(0xAC), lodsb: [{ o: 0xAC, s: atoms_1.S.B }], lodsw: [{ o: 0xAD, s: atoms_1.S.W }], lodsd: [{ o: 0xAD, s: atoms_1.S.D }], lodsq: [{ o: 0xAD, s: atoms_1.S.Q }], stos: tpl_movs(0xAA), 'in': [{ mr: false },
        { o: 0xE4, ops: [o.al, atoms_1.imm8] },
        { o: 0xE5, ops: [o.ax, atoms_1.imm8] },
        { o: 0xE5, ops: [o.eax, atoms_1.imm8] },
        { o: 0xEC, ops: [o.al, o.dx], s: atoms_1.S.B },
        { o: 0xED, ops: [o.ax, o.dx], s: atoms_1.S.W },
        { o: 0xED, ops: [o.eax, o.dx], s: atoms_1.S.D },
    ], out: [{ mr: false },
        { o: 0xE6, ops: [atoms_1.imm8, o.al] },
        { o: 0xE7, ops: [atoms_1.imm8, o.ax] },
        { o: 0xE7, ops: [atoms_1.imm8, o.eax] },
        { o: 0xEE, ops: [o.dx, o.al], s: atoms_1.S.B },
        { o: 0xEF, ops: [o.dx, o.ax], s: atoms_1.S.W },
        { o: 0xEF, ops: [o.dx, o.eax], s: atoms_1.S.D },
    ], ins: [{ o: 0x6D },
        { o: 0x6C, s: atoms_1.S.B },
        { s: atoms_1.S.W },
        { s: atoms_1.S.D },
    ], insb: [{ o: 0x6C }], insw: [{ o: 0x6D }], insd: [{ o: 0x6D }], outs: [{ o: 0x6F },
        { o: 0x6E, s: atoms_1.S.B },
        { s: atoms_1.S.W },
        { s: atoms_1.S.D },
    ], enter: [{ o: 0xC8, ops: [atoms_1.imm16, atoms_1.imm8] },
    ], leave: [{ o: 0xC9 },
        { s: atoms_1.S.W },
        { s: atoms_1.S.D, mod: atoms_1.M.COMP | atoms_1.M.LEG },
        { s: atoms_1.S.Q, mod: atoms_1.M.X64 },
    ], stc: [{ o: 0xF9 }], clc: [{ o: 0xF8 }], cmc: [{ o: 0xF5 }], cld: [{ o: 0xFC }], std: [{ o: 0xFD }], pushf: [{ o: 0x9C }], popf: [{ o: 0x9D }], sti: [{ o: 0xFB }], cli: [{ o: 0xFA }], clac: [{ o: 0x0F01CA }], lds: [{ o: 0xC5, mod: atoms_1.M.COMP | atoms_1.M.LEG },
        { ops: [atoms_1.r16, atoms_1.m] },
        { ops: [atoms_1.r32, atoms_1.m] },
    ], les: [{ o: 0xC4, mod: atoms_1.M.COMP | atoms_1.M.LEG },
        { ops: [atoms_1.r16, atoms_1.m] },
        { ops: [atoms_1.r32, atoms_1.m] },
    ], lfs: tpl_lss(0x0FB4), lgs: tpl_lss(0x0FB5), lss: tpl_lss(), lea: [{ o: 0x8D },
        { ops: [atoms_1.r16, atoms_1.m] },
        { ops: [atoms_1.r32, atoms_1.m] },
        { ops: [atoms_1.r64, atoms_1.m] },
    ], nop: [{},
        { o: 0x90 },
        { o: 0x0F1F, or: 0, ops: [atoms_1.rm16] },
        { o: 0x0F1F, or: 0, ops: [atoms_1.rm32] },
    ], ud2: [{ o: 0x0F0B }], xlat: [{ o: 0xD7 }], cpuid: [{ o: 0x0FA2 }], movbe: [{},
        { o: 0x0F38F0, ops: [atoms_1.r16, atoms_1.m16], dbit: true },
        { o: 0x0F38F0, ops: [atoms_1.r32, atoms_1.m32], dbit: true },
        { o: 0x0F38F0, ops: [atoms_1.r64, atoms_1.m64], dbit: true },
        { o: 0x0F38F1, ops: [atoms_1.m16, atoms_1.r16], dbit: true },
        { o: 0x0F38F1, ops: [atoms_1.m32, atoms_1.r32], dbit: true },
        { o: 0x0F38F1, ops: [atoms_1.m64, atoms_1.r64], dbit: true },
    ], prefetchw: [{ o: 0x0F0D, or: 1, ops: [atoms_1.m] }], prefetchwt1: [{ o: 0x0F0D, or: 2, ops: [atoms_1.m] }], cflush: [{ o: 0x0FAE, or: 7, ops: [atoms_1.m] }], cflushopt: [{ o: 0x0FAE, or: 7, pfx: [0x66], ops: [atoms_1.m] }], xsave: [{ o: 0x0FAE, or: 4, ops: [atoms_1.m] }], xsavec: [{ o: 0x0FC7, or: 4, ops: [atoms_1.m] }], xsaveopt: [{ o: 0x0FAE, or: 6, ops: [atoms_1.m] }], xrstor: [{ o: 0x0FAE, or: 5, ops: [atoms_1.m] }], xgetbv: [{ o: 0x0F01D0 }], rdrand: [{ o: 0x0FC7, or: 6 },
        { ops: [atoms_1.r16] },
        { ops: [atoms_1.r32] },
        { ops: [atoms_1.r64] },
    ], rdseed: [{ o: 0x0FC7, or: 7 },
        { ops: [atoms_1.r16] },
        { ops: [atoms_1.r32] },
        { ops: [atoms_1.r64] },
    ], syscall: [{ o: 0x0F05 }], sysret: [{ o: 0x0F07 }], sysenter: [{ o: 0x0F34 }], sysexit: [{ o: 0x0F35 }], vextractf128: [{ o: 0x19, vex: '256.66.0F3A.W0', ops: [[atoms_1.xmm, atoms_1.m], atoms_1.ymm, atoms_1.imm8], s: atoms_1.S.X }], vcvtph2ps: [{ o: 0x13, vex: '256.66.0F38.W0', ops: [atoms_1.ymm, [atoms_1.xmm, atoms_1.m]], s: 256 }], vfmadd132pd: [{ o: 0x98, vex: 'DDS.128.66.0F38.W1', en: 'rvm', ops: [atoms_1.xmm, atoms_1.xmm, [atoms_1.xmm, atoms_1.m]] }] });
