"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var operand_1 = require("../../x86/operand");
var atoms_1 = require("../atoms");
function tpl_and(o_al, o_imm, or_imm, o_reg, lock) {
    if (o_al === void 0) { o_al = 0x24; }
    if (o_imm === void 0) { o_imm = 0x80; }
    if (or_imm === void 0) { or_imm = 4; }
    if (o_reg === void 0) { o_reg = 0x20; }
    if (lock === void 0) { lock = true; }
    return [{ lock: lock },
        { o: o_al, ops: [operand_1.al, atoms_1.imm8], mr: false },
        { o: o_al + 1, ops: [operand_1.ax, atoms_1.imm16], mr: false },
        { o: o_al + 1, ops: [operand_1.eax, atoms_1.imm32], mr: false },
        { o: o_al + 1, ops: [operand_1.rax, atoms_1.imm32], mr: false },
        { o: o_imm, or: or_imm, ops: [atoms_1.rm8, atoms_1.imm8] },
        { o: o_imm + 1, or: or_imm, ops: [atoms_1.rm16, atoms_1.imm16] },
        { o: o_imm + 1, or: or_imm, ops: [atoms_1.rm32, atoms_1.imm32] },
        { o: o_imm + 1, or: or_imm, ops: [atoms_1.rm64, atoms_1.imm32] },
        { o: o_imm + 3, or: or_imm, ops: [atoms_1.rm16, atoms_1.imm8] },
        { o: o_imm + 3, or: or_imm, ops: [atoms_1.rm32, atoms_1.imm8] },
        { o: o_imm + 3, or: or_imm, ops: [atoms_1.rm64, atoms_1.imm8] },
        { o: o_reg, ops: [atoms_1.rm8, atoms_1.r8], en: 'mr', dbit: true },
        { o: o_reg + 2, ops: [atoms_1.r8, atoms_1.rm8], dbit: true },
        { o: o_reg + 1, ops: [atoms_1.rm16, atoms_1.r16], en: 'mr', dbit: true },
        { o: o_reg + 3, ops: [atoms_1.r16, atoms_1.rm16], dbit: true },
        { o: o_reg + 1, ops: [atoms_1.rm32, atoms_1.r32], en: 'mr', dbit: true },
        { o: o_reg + 3, ops: [atoms_1.r32, atoms_1.rm32], dbit: true },
        { o: o_reg + 1, ops: [atoms_1.rm64, atoms_1.r64], en: 'mr', dbit: true },
        { o: o_reg + 3, ops: [atoms_1.r64, atoms_1.rm64], dbit: true },
    ];
}
exports.default = {
    add: tpl_and(0x04, 0x80, 0, 0x00),
    adc: tpl_and(0x14, 0x80, 2, 0x10),
    sub: tpl_and(0x2C, 0x80, 5, 0x28),
    sbb: tpl_and(0x1C, 0x80, 3, 0x18),
    cmp: tpl_and(0x3C, 0x80, 7, 0x38, false),
    and: tpl_and(),
    or: tpl_and(0x0C, 0x80, 1, 0x08),
    xor: tpl_and(0x34, 0x80, 6, 0x30),
};
