"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var operand_1 = require("../../x86/operand");
var atoms_1 = require("../atoms");
function tpl_sar(or, o_r, o_imm) {
    if (or === void 0) { or = 7; }
    if (o_r === void 0) { o_r = 0xD0; }
    if (o_imm === void 0) { o_imm = 0xC0; }
    return [{ or: or },
        { o: o_r, ops: [atoms_1.rm8, 1] },
        { o: o_r + 2, ops: [atoms_1.rm8, operand_1.cl], s: atoms_1.S.B },
        { o: o_imm, ops: [atoms_1.rm8, atoms_1.imm8] },
        { o: o_r + 1, ops: [atoms_1.rm16, 1] },
        { o: o_r + 3, ops: [atoms_1.rm16, operand_1.cl], s: atoms_1.S.W },
        { o: o_imm + 1, ops: [atoms_1.rm16, atoms_1.imm8] },
        { o: o_r + 1, ops: [atoms_1.rm32, 1] },
        { o: o_r + 1, ops: [atoms_1.rm64, 1] },
        { o: o_r + 3, ops: [atoms_1.rm32, operand_1.cl], s: atoms_1.S.D },
        { o: o_r + 3, ops: [atoms_1.rm64, operand_1.cl], s: atoms_1.S.Q },
        { o: o_imm + 1, ops: [atoms_1.rm32, atoms_1.imm8] },
        { o: o_imm + 1, ops: [atoms_1.rm64, atoms_1.imm8] },
    ];
}
exports.default = {
    sar: tpl_sar(),
    shr: tpl_sar(5),
    shl: tpl_sar(4, 0xD0, 0xC0),
    sal: ['shl'],
    ror: tpl_sar(1),
    rol: tpl_sar(0),
    rcr: tpl_sar(3),
    rcl: tpl_sar(2),
};
