"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var register_1 = require("./operand/register");
var consts_1 = require("./consts");
exports.M = consts_1.MODE;
exports.EXT = consts_1.EXT;
exports.INS = consts_1.INS;
var operand_1 = require("../../operand");
var memory_1 = require("./operand/memory");
__export(require("./operand/generator"));
__export(require("../../atoms"));
exports.r8 = register_1.Register8;
exports.r16 = register_1.Register16;
exports.r32 = register_1.Register32;
exports.r64 = register_1.Register64;
exports.sreg = register_1.RegisterSegment;
exports.mm = register_1.RegisterMm;
exports.st = register_1.RegisterSt;
exports.xmm = register_1.RegisterXmm;
exports.ymm = register_1.RegisterYmm;
exports.zmm = register_1.RegisterZmm;
exports.bnd = register_1.RegisterBounds;
exports.cr = register_1.RegisterCr;
exports.dr = register_1.RegisterDr;
exports.m = operand_1.Memory;
exports.m8 = memory_1.Memory8;
exports.m16 = memory_1.Memory16;
exports.m32 = memory_1.Memory32;
exports.m64 = memory_1.Memory64;
exports.m128 = memory_1.Memory128;
exports.m256 = memory_1.Memory256;
exports.m512 = memory_1.Memory512;
exports.rm8 = [exports.r8, exports.m];
exports.rm16 = [exports.r16, exports.m];
exports.rm32 = [exports.r32, exports.m];
exports.rm64 = [exports.r64, exports.m];
exports.xmmm = [exports.xmm, exports.m];
exports.xmm_xmmm = [exports.xmm, exports.xmmm];
exports.xmm_xmm_xmmm = [exports.xmm, exports.xmm, exports.xmmm];
exports.ymmm = [exports.ymm, exports.m];
exports.ymm_ymmm = [exports.ymm, exports.ymmm];
exports.ymm_ymm_ymmm = [exports.ymm, exports.ymm, exports.ymmm];
exports.zmmm = [exports.zmm, exports.m];
exports.zmm_zmmm = [exports.zmm, exports.zmmm];
exports.zmm_zmm_zmmm = [exports.zmm, exports.zmm, exports.zmmm];
