"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var operand_1 = require("../../../operand");
var register_1 = require("./register");
var OperandsX86 = (function (_super) {
    __extends(OperandsX86, _super);
    function OperandsX86() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    OperandsX86.findSize = function (ops) {
        for (var _i = 0, ops_1 = ops; _i < ops_1.length; _i++) {
            var operand = ops_1[_i];
            if (operand instanceof register_1.RegisterX86)
                return operand.size;
        }
        return operand_1.SIZE.NONE;
    };
    OperandsX86.prototype.hasImmediate = function () {
        return !!this.getImmediate();
    };
    OperandsX86.prototype.hasExtendedRegister = function () {
        for (var _i = 0, _a = this.list; _i < _a.length; _i++) {
            var op = _a[_i];
            if (op instanceof operand_1.Register) {
                if (op.idSize() > 3)
                    return true;
            }
            else if (op instanceof operand_1.Memory) {
                var mem = op;
                if (mem.base && (mem.base.idSize() > 3))
                    return true;
                if (mem.index && (mem.index.idSize() > 3))
                    return true;
            }
        }
        return false;
    };
    return OperandsX86;
}(operand_1.Operands));
exports.OperandsX86 = OperandsX86;
__export(require("./displacement"));
__export(require("./register"));
__export(require("./memory"));
__export(require("./generator"));
