"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var operand_1 = require("../../../operand");
var regfile_1 = require("../regfile");
var memory_1 = require("./memory");
var RegisterX86 = (function (_super) {
    __extends(RegisterX86, _super);
    function RegisterX86(id, size) {
        var _this = _super.call(this, id, size) || this;
        _this.name = RegisterX86.getName(size, id).toLowerCase();
        return _this;
    }
    RegisterX86.getName = function (size, id) {
        var def = 'REG';
        if (typeof size !== 'number')
            return def;
        if (typeof id !== 'number')
            return def;
        switch (size) {
            case operand_1.SIZE.Q:
                return regfile_1.R64[id];
            case operand_1.SIZE.D:
                return regfile_1.R32[id];
            case operand_1.SIZE.W:
                return regfile_1.R16[id];
            case operand_1.SIZE.B:
                if (this instanceof Register8High)
                    return regfile_1.R8H[id];
                else
                    return regfile_1.R8[id];
            default:
                return def;
        }
    };
    RegisterX86.prototype.ref = function () {
        return (new memory_1.MemoryX86).ref(this);
    };
    RegisterX86.prototype.ind = function (scale_factor) {
        return (new memory_1.MemoryX86).ind(this, scale_factor);
    };
    RegisterX86.prototype.disp = function (value) {
        return (new memory_1.MemoryX86).ref(this).disp(value);
    };
    RegisterX86.prototype.isExtended = function () {
        return this.id > 7;
    };
    return RegisterX86;
}(operand_1.Register));
exports.RegisterX86 = RegisterX86;
var RegisterGP = (function (_super) {
    __extends(RegisterGP, _super);
    function RegisterGP() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return RegisterGP;
}(RegisterX86));
exports.RegisterGP = RegisterGP;
var Register8 = (function (_super) {
    __extends(Register8, _super);
    function Register8(id) {
        return _super.call(this, id, operand_1.SIZE.B) || this;
    }
    return Register8;
}(RegisterGP));
exports.Register8 = Register8;
var Register8High = (function (_super) {
    __extends(Register8High, _super);
    function Register8High() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return Register8High;
}(Register8));
exports.Register8High = Register8High;
var Register16 = (function (_super) {
    __extends(Register16, _super);
    function Register16(id) {
        return _super.call(this, id, operand_1.SIZE.W) || this;
    }
    return Register16;
}(RegisterX86));
exports.Register16 = Register16;
var Register32 = (function (_super) {
    __extends(Register32, _super);
    function Register32(id) {
        return _super.call(this, id, operand_1.SIZE.D) || this;
    }
    return Register32;
}(RegisterGP));
exports.Register32 = Register32;
var Register64 = (function (_super) {
    __extends(Register64, _super);
    function Register64(id) {
        return _super.call(this, id, operand_1.SIZE.Q) || this;
    }
    return Register64;
}(RegisterGP));
exports.Register64 = Register64;
var Register128 = (function (_super) {
    __extends(Register128, _super);
    function Register128(id) {
        return _super.call(this, id, operand_1.SIZE.O) || this;
    }
    return Register128;
}(RegisterGP));
exports.Register128 = Register128;
var Register256 = (function (_super) {
    __extends(Register256, _super);
    function Register256(id) {
        return _super.call(this, id, operand_1.SIZE.H) || this;
    }
    return Register256;
}(RegisterGP));
exports.Register256 = Register256;
var Register512 = (function (_super) {
    __extends(Register512, _super);
    function Register512(id) {
        return _super.call(this, id, operand_1.SIZE.I) || this;
    }
    return Register512;
}(RegisterGP));
exports.Register512 = Register512;
var RegisterRip = (function (_super) {
    __extends(RegisterRip, _super);
    function RegisterRip() {
        var _this = _super.call(this, 0, operand_1.SIZE.Q) || this;
        _this.name = RegisterRip.atomName;
        return _this;
    }
    RegisterRip.atomName = 'rip';
    return RegisterRip;
}(RegisterX86));
exports.RegisterRip = RegisterRip;
var RegisterBounds = (function (_super) {
    __extends(RegisterBounds, _super);
    function RegisterBounds(id) {
        return _super.call(this, id, operand_1.SIZE.O) || this;
    }
    return RegisterBounds;
}(RegisterX86));
exports.RegisterBounds = RegisterBounds;
var RegisterFloatingPoint = (function (_super) {
    __extends(RegisterFloatingPoint, _super);
    function RegisterFloatingPoint() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RegisterFloatingPoint.atomName = 'fp';
    return RegisterFloatingPoint;
}(RegisterX86));
exports.RegisterFloatingPoint = RegisterFloatingPoint;
var RegisterMm = (function (_super) {
    __extends(RegisterMm, _super);
    function RegisterMm(id) {
        var _this = _super.call(this, id, operand_1.SIZE.O) || this;
        _this.name = RegisterMm.atomName + id;
        return _this;
    }
    RegisterMm.atomName = 'mm';
    return RegisterMm;
}(RegisterFloatingPoint));
exports.RegisterMm = RegisterMm;
var RegisterSt = (function (_super) {
    __extends(RegisterSt, _super);
    function RegisterSt(id) {
        var _this = _super.call(this, id, operand_1.SIZE.T) || this;
        _this.name = RegisterSt.atomName + id;
        return _this;
    }
    RegisterSt.atomName = 'st';
    return RegisterSt;
}(RegisterFloatingPoint));
exports.RegisterSt = RegisterSt;
var RegisterVector = (function (_super) {
    __extends(RegisterVector, _super);
    function RegisterVector() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return RegisterVector;
}(RegisterX86));
exports.RegisterVector = RegisterVector;
var RegisterXmm = (function (_super) {
    __extends(RegisterXmm, _super);
    function RegisterXmm(id) {
        var _this = _super.call(this, id, operand_1.SIZE.O) || this;
        _this.name = RegisterXmm.atomName + id;
        return _this;
    }
    RegisterXmm.atomName = 'xmm';
    return RegisterXmm;
}(RegisterVector));
exports.RegisterXmm = RegisterXmm;
var RegisterYmm = (function (_super) {
    __extends(RegisterYmm, _super);
    function RegisterYmm(id) {
        var _this = _super.call(this, id, operand_1.SIZE.H) || this;
        _this.name = RegisterYmm.atomName + id;
        return _this;
    }
    RegisterYmm.atomName = 'ymm';
    return RegisterYmm;
}(RegisterVector));
exports.RegisterYmm = RegisterYmm;
var RegisterZmm = (function (_super) {
    __extends(RegisterZmm, _super);
    function RegisterZmm(id) {
        var _this = _super.call(this, id, operand_1.SIZE.I) || this;
        _this.name = RegisterZmm.atomName + id;
        return _this;
    }
    RegisterZmm.atomName = 'zmm';
    return RegisterZmm;
}(RegisterVector));
exports.RegisterZmm = RegisterZmm;
var RegisterK = (function (_super) {
    __extends(RegisterK, _super);
    function RegisterK(id) {
        var _this = _super.call(this, id, operand_1.SIZE.Q) || this;
        _this.name = RegisterK.atomName + id;
        return _this;
    }
    RegisterK.atomName = 'k';
    return RegisterK;
}(RegisterX86));
exports.RegisterK = RegisterK;
var RegisterCr = (function (_super) {
    __extends(RegisterCr, _super);
    function RegisterCr(id) {
        var _this = _super.call(this, id, operand_1.SIZE.Q) || this;
        _this.name = RegisterCr.atomName + id;
        return _this;
    }
    RegisterCr.atomName = 'cr';
    return RegisterCr;
}(RegisterX86));
exports.RegisterCr = RegisterCr;
var RegisterDr = (function (_super) {
    __extends(RegisterDr, _super);
    function RegisterDr(id) {
        var _this = _super.call(this, id, operand_1.SIZE.Q) || this;
        _this.name = RegisterDr.atomName + id;
        return _this;
    }
    RegisterDr.atomName = 'dr';
    return RegisterDr;
}(RegisterX86));
exports.RegisterDr = RegisterDr;
var RegisterSegment = (function (_super) {
    __extends(RegisterSegment, _super);
    function RegisterSegment(id) {
        return _super.call(this, id, operand_1.SIZE.W) || this;
    }
    RegisterSegment.atomName = 'sreg';
    return RegisterSegment;
}(RegisterX86));
exports.RegisterSegment = RegisterSegment;
