"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function parseVexString(vstr) {
    var vdef = {
        vvvv: '',
        L: 0,
        pp: 0,
        mmmmm: 1,
        W: 1,
        WIG: false,
    };
    if (vstr.indexOf('NDS') > -1)
        vdef.vvvv = 'NDS';
    else if (vstr.indexOf('NDD') > -1)
        vdef.vvvv = 'NDD';
    else if (vstr.indexOf('DDS') > -1)
        vdef.vvvv = 'DDS';
    if (vstr.indexOf('256') > -1)
        vdef.L = 1;
    else if (vstr.indexOf('512') > -1)
        vdef.L = 2;
    if (vstr.indexOf('.66.') > -1)
        vdef.pp = 1;
    else if (vstr.indexOf('.F2.') > -1)
        vdef.pp = 3;
    else if (vstr.indexOf('.F3.') > -1)
        vdef.pp = 2;
    if (vstr.indexOf('0F38') > -1)
        vdef.mmmmm = 2;
    else if (vstr.indexOf('0F3A') > -1)
        vdef.mmmmm = 3;
    else if (vstr.indexOf('0F') > -1)
        vdef.mmmmm = 1;
    if (vstr.indexOf('W0') > -1)
        vdef.W = 0;
    if (vstr.indexOf('WIG') > -1)
        vdef.WIG = true;
    return vdef;
}
exports.default = parseVexString;
