"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var InstructionPart_1 = require("./InstructionPart");
var regfile_1 = require("../regfile");
var displacement_1 = require("../operand/displacement");
var Modrm = (function (_super) {
    __extends(Modrm, _super);
    function Modrm(mod, reg, rm) {
        var _this = _super.call(this) || this;
        _this.mod = 0;
        _this.reg = 0;
        _this.rm = 0;
        _this.mod = mod;
        _this.reg = reg;
        _this.rm = rm;
        return _this;
    }
    Modrm.getModDispSize = function (mem) {
        if (!mem.displacement || !mem.base)
            return Modrm.MOD.INDIRECT;
        else if (mem.displacement.size === displacement_1.DisplacementValue.SIZE.DISP8)
            return Modrm.MOD.DISP8;
        else if (mem.displacement.size <= displacement_1.DisplacementValue.SIZE.DISP32)
            return Modrm.MOD.DISP32;
        else
            throw Error('64-bit displacement not supported yet.');
    };
    Modrm.prototype.write = function (arr) {
        arr.push((this.mod << 6) | (this.reg << 3) | this.rm);
    };
    Modrm.MOD = {
        INDIRECT: 0,
        DISP8: 1,
        DISP32: 2,
        REG_TO_REG: 3,
    };
    Modrm.RM = {
        NEEDS_SIB: regfile_1.R64.RSP & 7,
        INDIRECT_DISP: regfile_1.R64.RBP & 7,
    };
    return Modrm;
}(InstructionPart_1.default));
exports.default = Modrm;
