"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var InstructionPart_1 = require("./InstructionPart");
var Opcode = (function (_super) {
    __extends(Opcode, _super);
    function Opcode() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.op = 0;
        return _this;
    }
    Opcode.prototype.bytes = function () {
        if (this.op > 0xFFFF)
            return 3;
        if (this.op > 0xFF)
            return 2;
        return 1;
    };
    Opcode.prototype.write = function (arr) {
        var op = this.op;
        if (op > 0xFFFF)
            arr.push((op & 0xFF0000) >> 16);
        if (op > 0xFF)
            arr.push((op & 0xFF00) >> 8);
        arr.push(op & 0xFF);
    };
    Opcode.MASK_SIZE = 16777214;
    Opcode.MASK_DIRECTION = 16777213;
    Opcode.MASK_OP = 16777208;
    Opcode.SIZE = {
        BYTE: 0,
        WORD_OR_DOUBLE: 1,
    };
    Opcode.DIRECTION = {
        REG_IS_SRC: 0,
        REG_IS_DST: 2,
    };
    return Opcode;
}(InstructionPart_1.default));
exports.default = Opcode;
