"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var InstructionPart_1 = require("./InstructionPart");
var regfile_1 = require("../regfile");
var Sib = (function (_super) {
    __extends(Sib, _super);
    function Sib(scalefactor, I, B) {
        var _this = _super.call(this) || this;
        _this.S = 0;
        _this.I = 0;
        _this.B = 0;
        _this.setScale(scalefactor);
        _this.I = I;
        _this.B = B;
        return _this;
    }
    Sib.prototype.setScale = function (scalefactor) {
        switch (scalefactor) {
            case 1:
                this.S = 0;
                break;
            case 2:
                this.S = 1;
                break;
            case 4:
                this.S = 2;
                break;
            case 8:
                this.S = 3;
                break;
            default: this.S = 0;
        }
    };
    Sib.prototype.write = function (arr) {
        arr.push((this.S << 6) | (this.I << 3) | this.B);
    };
    Sib.INDEX_NONE = regfile_1.R64.RSP & 7;
    Sib.BASE_NONE = regfile_1.R64.RBP & 7;
    return Sib;
}(InstructionPart_1.default));
exports.default = Sib;
