"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var PluginData_1 = require("../plugins/data/PluginData");
var PluginUtil_1 = require("../plugins/util/PluginUtil");
var PluginX86_1 = require("../plugins/x86/PluginX86");
var PluginX64_1 = require("../plugins/x64/PluginX64");
var PluginTemplate_1 = require("../plugins/template/PluginTemplate");
var operand_1 = require("../operand");
var consts_1 = require("../plugins/x86/consts");
var PresetX64 = function (opts) {
    if (opts === void 0) { opts = {}; }
    var plugins = [
        new PluginTemplate_1.default(),
        new PluginX64_1.default(),
        new PluginX86_1.default(),
        new PluginData_1.default(),
        new PluginUtil_1.default(),
    ];
    return __assign({ operandSize: operand_1.SIZE.D, addressSize: operand_1.SIZE.Q, mode: consts_1.MODE.X32_64 }, opts, { plugins: plugins });
};
exports.default = PresetX64;
